/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, runOn, Number_$type, delegateRemove, typeCast, delegateCombine, enumGetBox } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { DOMExecutionContext } from "igniteui-webcomponents-core";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { NativeUIComponent } from "igniteui-webcomponents-core";
import { Size } from "igniteui-webcomponents-core";
import { NativeUI } from "igniteui-webcomponents-core";
import { FontUtil } from "igniteui-webcomponents-core";
import { SRProvider } from "igniteui-webcomponents-core";
import { IDataSource_$type } from "igniteui-webcomponents-core";
import { ListPanelOrientation_$type } from "./ListPanelOrientation";
import { DeviceUtils } from "igniteui-webcomponents-core";
import { FastIterationDictionary$2 } from "igniteui-webcomponents-core";
import { ListPanelItemModel } from "./ListPanelItemModel";
import { Stack$1 } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { NativeUIInputsFactory } from "igniteui-webcomponents-core";
import { ListPanelContentRefreshedEventArgs } from "./ListPanelContentRefreshedEventArgs";
import { ListPanelTemplateItemUpdatingEventArgs } from "./ListPanelTemplateItemUpdatingEventArgs";
import { ListPanelItemPresenter } from "./ListPanelItemPresenter";
import { ListPanelTemplateWidthRequestedEventArgs } from "./ListPanelTemplateWidthRequestedEventArgs";
import { ListPanelTemplateHeightRequestedEventArgs } from "./ListPanelTemplateHeightRequestedEventArgs";
import { BrushUtil } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
import { IDataSourceUpdateNotifier_$type } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let ListPanelView = /*@__PURE__*/ (() => {
    class ListPanelView extends Base {
        constructor() {
            super();
            this.n = null;
            this.m = null;
            this.a = null;
            this.i = null;
            this.l = null;
            this.e = null;
            this.k = null;
            this.b = ((() => {
                let $ret = new FontInfo();
                $ret.q = "Verdana";
                $ret.f = 13;
                $ret.t = "Normal";
                $ret.v = "Normal";
                $ret.r = "Normal";
                return $ret;
            })());
            this.aa = new Size();
            this.c = null;
            this._gridExternal = null;
            this.f = false;
            this.j = null;
        }
        p() {
            return this.i;
        }
        v() {
        }
        t(a) {
            if (a == null) {
                this.i = null;
                return;
            }
            this.a.c = new DOMExecutionContext(a);
            this.i = a;
            this.l = this.i.createElement("canvas");
            this.e = new RenderingContext(new CanvasViewRenderer(), this.i.get2DCanvasContext(this.l));
            this.k = this.i.createElement("div");
            this.y();
            NativeUIComponent.ar(this.p(), 9, (b) => {
                let c = b;
                this.a.by(c);
                this.i.append(c.al);
            });
            let b = Math.round(a.rootWrapper.width());
            let c = Math.round(a.rootWrapper.height());
            this.i.rootWrapper.setStyleProperty("position", "relative");
        }
        y() {
        }
        x() {
            if (this.i != null) {
            }
        }
        s() {
            if (this.i == null) {
                return;
            }
            let a = this.i.rootWrapper.width();
            let b = this.i.rootWrapper.height();
            this.aa = new Size(1, a, b);
            this.a.cg(this.aa);
            if (this.a.u != null) {
                this.a.cs();
            }
        }
        z() {
            let a = this.i;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.q(b, this.a.cy);
                NativeUI.m(b, this.a.cv);
            }
        }
        d() {
            return this.b;
        }
        u() {
        }
        w() {
        }
        r(a, b) {
            this.i.rootWrapper.setStyleProperty("height", b + "px");
        }
        g() {
            return this.aa.width;
        }
        h(a) {
            this.c = this.a.t();
            return FontUtil.measureStringWidth(a, this.c, this.e);
        }
        q(a, b) {
            if (this.j == null) {
                this.j = this.i.createElement("div");
            }
            b(this.j.getNativeElement());
        }
    }
    ListPanelView.$t = /*@__PURE__*/ markType(ListPanelView, 'ListPanelView');
    return ListPanelView;
})();
/**
 * @hidden
 */
export let ListPanel = /*@__PURE__*/ (() => {
    class ListPanel extends Base {
        get w() {
            if (this.v == null) {
                this.v = new SRProvider(this.o.i);
                this.v.cb("Layouts");
            }
            return this.v;
        }
        by(a) {
            this.h = new ListPanelLayoutPanel(a);
        }
        constructor() {
            super();
            this.o = null;
            this.u = null;
            this.y = false;
            this.v = null;
            this.h = null;
            this.propertyChanged = null;
            this.ba = null;
            this.a = null;
            this.ag = false;
            this.a2 = -1;
            this.ar = DeviceUtils.g(42);
            this.r = null;
            this.x = true;
            this.bb = null;
            this.as = 0;
            this.aq = NaN;
            this.ap = 0;
            this.ad = false;
            this.z = false;
            this.ac = false;
            this.contentRefreshed = null;
            this.rowUpdating = null;
            this.q = new FastIterationDictionary$2(Number_$type, ListPanelItemModel.$, 0);
            this.itemWidthRequested = null;
            this.itemHeightRequested = null;
            this.p = new FastIterationDictionary$2(ListPanelItemModel.$, ListPanelItemModel.$, 0);
            this.ao = new Stack$1(ListPanelItemModel.$);
            this.al = new List$1(Number_$type, 0);
            this.ak = new List$1(Number_$type, 0);
            this.an = new List$1(Number_$type, 0);
            this.am = new List$1(Number_$type, 0);
            this.ae = true;
            this.ab = true;
            this.a0 = -1;
            this.a1 = -1;
            this.d = null;
            this.c = null;
            this.ct = ListPanel.cw;
            this.i = ListPanel.j;
            this.aa = ListPanel.af;
            this.cu = ListPanel.cx;
            NativeUIInputsFactory.n();
            let a = new ListPanelView();
            a.a = this;
            this.o = a;
            this.o.v();
        }
        cg(a) {
            this.aq = a.width;
            this.ck();
        }
        get itemsSource() {
            return this.ba;
        }
        set itemsSource(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.cd("ItemsSource", b, this.ba);
            }
        }
        get actualDataSource() {
            return this.a;
        }
        set actualDataSource(a) {
            let b = this.a;
            this.a = a;
            if (this.a != b) {
                this.cd("ActualDataSource", b, this.a);
            }
        }
        notifySizeChanged() {
            this.o.s();
        }
        destroy() {
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.o.t(a);
        }
        get a9() {
            return this.a2;
        }
        set a9(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.cd("RowHeight", b, this.a2);
            }
        }
        get av() {
            return this.ar;
        }
        set av(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.cd("ActualRowHeight", b, this.ar);
            }
        }
        get s() {
            return this.r;
        }
        set s(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.cd("CellTextStyle", b, this.r);
            }
        }
        t() {
            if (this.s == null) {
                return this.o.d();
            }
            return this.s;
        }
        get ah() {
            return this.k == 1;
        }
        cd(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ch(a, b, c);
        }
        bp(a, b) {
            this.cb();
        }
        ck() {
            if (this.ac) {
                return;
            }
            this.ac = true;
            this.c.enqueueAction(runOn(this, this.br));
        }
        br() {
            if (!this.ac) {
                return;
            }
            this.ac = false;
            if (this.ab) {
                this.bn();
                if (this.k == 1) {
                    this.h.e(new Size(1, this.aq, this.ap));
                }
            }
            if (this.ae) {
                this.bo();
            }
            this.cl();
            this.co();
            if (this.contentRefreshed != null) {
                this.contentRefreshed(this, new ListPanelContentRefreshedEventArgs());
            }
        }
        co() {
            if (this.actualDataSource == null) {
                return;
            }
            for (let a = 0; a < this.p.o.count; a++) {
                if (this.p.p._inner[a]) {
                    continue;
                }
                let b = this.p.o._inner[a];
                let c = this.p.q._inner[a];
                this.h.d(c);
            }
            let d = 0;
            for (let e = 0; e < this.q.o.count; e++) {
                if (this.q.p._inner[e]) {
                    continue;
                }
                let f = this.q.o._inner[e];
                let g = this.q.q._inner[e];
                this.bu(g);
                this.bs(g);
                this.h.b(this, g);
            }
        }
        bs(a) {
            if (a.f) {
                a.f = false;
                this.bv(a);
            }
        }
        bv(a) {
            if (this.rowUpdating != null) {
                this.rowUpdating(this, ((() => {
                    let $ret = new ListPanelTemplateItemUpdatingEventArgs();
                    $ret.a = a;
                    $ret.b = a.a.a;
                    $ret.c = a.a.a.al;
                    return $ret;
                })()));
            }
        }
        bu(a) {
            if (a.a != null) {
                return;
            }
            a.a = new ListPanelItemPresenter();
            NativeUIComponent.av(this.o.p(), 0, (b) => {
                let c = b;
                if (this.k == 0) {
                    c.f = 3;
                }
                else {
                    c.f = 0;
                }
                a.a.a = c;
            });
        }
        bo() {
            if (!this.ae) {
                return;
            }
            this.ae = false;
            this.bx();
            this.a0 = this.a7();
            this.a1 = this.a8();
            if (this.a0 == -1 || this.a1 == -1) {
                return;
            }
            let a = new List$1(Number_$type, 0);
            for (let b = 0; b < this.q.o.count; b++) {
                if (this.q.p._inner[b]) {
                    continue;
                }
                let c = this.q.o._inner[b];
                let d = this.q.q._inner[b];
                if (c < this.a0 || c > this.a1) {
                    a.add(c);
                }
            }
            for (let e = 0; e < a.count; e++) {
                this.cr(a._inner[e]);
            }
            for (let f = this.a0; f <= this.a1; f++) {
                this.bt(f);
                let g = this.q.item(f);
                g.l = this.az(f);
                g.j = this.ay(f);
            }
        }
        ay(a) {
            if (this.k == 0) {
                return 0;
            }
            else {
                return this.an._inner[a];
            }
        }
        az(a) {
            if (this.k == 1) {
                return 0;
            }
            else {
                if (this.ai) {
                    return this.al._inner[a];
                }
                else {
                    return a * this.av;
                }
            }
        }
        bt(a) {
            if (this.q.d(a)) {
                return;
            }
            let b = this.g(a);
            if (b.d) {
                this.p.f(b);
                b.d = false;
            }
            this.q.s(a, b);
        }
        g(a) {
            let b = this.ao.f > 0 ? this.ao.e() : new ListPanelItemModel();
            b.m = a;
            b.k = this.av;
            return b;
        }
        cr(a) {
            let b = this.q.item(a);
            this.cn(b);
            this.q.f(a);
            b.d = true;
            this.p.s(b, b);
        }
        cn(a) {
            this.ao.h(a);
        }
        a8() {
            if (this.actualDataSource == null || this.actualDataSource.actualSchema == null) {
                return -1;
            }
            return this.actualDataSource.actualCount - 1;
        }
        a7() {
            if (this.actualDataSource == null || this.actualDataSource.actualSchema == null) {
                return -1;
            }
            return 0;
        }
        ax(a) {
            if (this.am.count > 0 && a < this.am.count) {
                return this.am._inner[a];
            }
            return 0;
        }
        aw(a) {
            if (this.ak.count > 0 && a < this.ak.count) {
                return this.ak._inner[a];
            }
            return 0;
        }
        bn() {
            this.ak.clear();
            this.al.clear();
            this.am.clear();
            this.an.clear();
            if (this.actualDataSource != null && this.actualDataSource.actualSchema != null) {
                let a = this.ap;
                let b = isNaN_(this.aq) ? 0 : this.aq;
                if (this.k == 0) {
                    if (this.ai) {
                        let c = 0;
                        for (let d = 0; d < this.actualDataSource.actualCount; d++) {
                            this.al.add(c);
                            let e = this.av;
                            if (this.itemHeightRequested != null) {
                                let f = ((() => {
                                    let $ret = new ListPanelTemplateHeightRequestedEventArgs();
                                    $ret.b = d;
                                    $ret.c = this.actualDataSource.getItemAtIndex(d);
                                    $ret.a = e;
                                    return $ret;
                                })());
                                this.itemHeightRequested(this, f);
                                e = f.a;
                                c += e;
                            }
                            this.ak.add(e);
                        }
                        this.ap = c;
                    }
                    else {
                        this.ap = this.av * this.actualDataSource.actualCount;
                    }
                }
                else {
                    this.ap = this.av;
                    {
                        let g = 0;
                        for (let h = 0; h < this.actualDataSource.actualCount; h++) {
                            this.an.add(g);
                            let i = 0;
                            if (this.itemWidthRequested != null) {
                                let j = ((() => {
                                    let $ret = new ListPanelTemplateWidthRequestedEventArgs();
                                    $ret.b = h;
                                    $ret.c = this.actualDataSource.getItemAtIndex(h);
                                    $ret.a = i;
                                    return $ret;
                                })());
                                this.itemWidthRequested(this, j);
                                i = j.a;
                                g += i;
                            }
                            this.am.add(i);
                        }
                        this.aq = g;
                    }
                }
                if (a != this.ap || b != (isNaN_(this.aq) ? 0 : this.aq)) {
                    this.o.r(this.aq, this.ap);
                }
            }
        }
        bw() {
            if (this.ac) {
                this.br();
            }
        }
        cp() {
            let a = isNaN_(this.aq) ? 0 : this.aq;
            let b = this.ap;
            this.ad = true;
            this.b2(this.as);
            if (a != (isNaN_(this.aq) ? 0 : this.aq) || b != this.ap) {
                this.externalListPanel.onContentSizeChanged();
            }
            this.ad = false;
            this.b3();
            this.ck();
        }
        b3() {
            this.ae = true;
            this.a0 = -1;
            this.a1 = -1;
        }
        b2(a) {
            this.ab = true;
            this.as = a;
        }
        bx() {
            if (this.z) {
                this.z = false;
                this.cp();
                this.b1();
            }
        }
        cq() {
            if (this.z) {
                this.bx();
            }
            else {
                this.ck();
                this.bw();
            }
        }
        a6() {
            return this.a1;
        }
        a5() {
            return this.a0;
        }
        aj() {
            return this.a0 >= 0 && this.a1 >= 0;
        }
        b1() {
            if (!this.aj()) {
                return;
            }
            let a = this.a5();
            let b = this.a6();
            this.b0(a, b);
        }
        b0(a, b) {
            let c = this.a5();
            let d = this.a6();
            if (b < c || a > d) {
                return;
            }
            if (a < c) {
                a = c;
            }
            if (b > d) {
                b = d;
            }
            this.cl();
            this.cq();
        }
        cl() {
            if (this.actualDataSource == null || this.actualDataSource.actualCount == 0) {
                return;
            }
            for (let a = 0; a < this.q.q.count; a++) {
                if (this.q.p._inner[a]) {
                    continue;
                }
                let b = this.q.q._inner[a];
                b.o = this.actualDataSource.getItemAtIndex(b.m);
                b.k = this.av;
            }
        }
        cm(a) {
            if (this.actualDataSource == null || this.actualDataSource.actualCount == 0) {
                return;
            }
            if (this.q.d(a)) {
                let b = this.q.item(a);
                b.o = this.actualDataSource.getItemAtIndex(b.m);
                b.k = this.av;
            }
        }
        cj() {
            if (!this.z) {
                this.z = true;
                this.b3();
                this.ck();
            }
        }
        bz(a) {
            this.cm(a);
        }
        cb() {
            if (this.z) {
                this.bx();
            }
            else {
                this.cp();
                this.b1();
            }
        }
        get externalListPanel() {
            return this.d;
        }
        set externalListPanel(a) {
            this.d = a;
        }
        ch(a, b, c) {
            switch (a) {
                case "ItemsSource":
                    if (this.a != null) {
                        let d = this.a;
                        d.schemaChanged = delegateRemove(d.schemaChanged, runOn(this, this.bp));
                        this.a.updateNotifier = null;
                    }
                    if (typeCast(IDataSource_$type, this.itemsSource) !== null) {
                        this.actualDataSource = this.itemsSource;
                    }
                    else {
                        let e = this.externalListPanel.createLocalDataSource(this.itemsSource);
                        this.actualDataSource = e;
                    }
                    if (this.a != null) {
                        let f = this.a;
                        f.schemaChanged = delegateCombine(f.schemaChanged, runOn(this, this.bp));
                        this.a.updateNotifier = new ListPanelDataSourceNotificationBridge(this);
                        if (this.a.actualSchema != null) {
                            this.cj();
                            this.c.enqueueAction(() => this.cb());
                        }
                    }
                    break;
                case "RowHeight":
                    this.av = this.a9;
                    break;
                case "CellTextStyle":
                    this.b1();
                    break;
                case "BackgroundColor":
                case "TextColor":
                    this.b1();
                    break;
                case "Orientation":
                case "ActualRowHeight":
                    this.cp();
                    break;
            }
        }
        cs() {
            if (this.u == null) {
                return;
            }
            let a = this.a9 == -1 ? 38 : this.a9;
            let b = this.cv;
            let c = this.t();
        }
        cz() {
            let a = this.ap;
            let b = 0;
            if (!isNaN_(a) && a >= 0) {
                b = a;
            }
            let c = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
            let d = 0;
            for (let e = 0; e < this.q.o.count; e++) {
                if (this.q.p._inner[e]) {
                    continue;
                }
                if (this.k == 1) {
                    d += this.am._inner[e];
                }
                else {
                    d = this.aq;
                }
            }
            return new Size(1, d, b);
        }
        ca(a, b) {
        }
        cf(a, b, c) {
            if (this.k == 0) {
                if (this.ai) {
                    let d = this.av;
                    if (this.itemHeightRequested != null) {
                        let e = new ListPanelTemplateHeightRequestedEventArgs();
                        e.c = c;
                        e.b = a;
                        e.a = d;
                        this.itemHeightRequested(this, e);
                        d = e.a;
                    }
                    let f = this.ak._inner[a];
                    this.ak._inner[a] = d;
                    let g = d - f;
                    for (let h = a; h < this.actualDataSource.actualCount; h++) {
                        this.al._inner[h] += g;
                    }
                }
            }
            else {
                let i = 0;
                if (this.itemWidthRequested != null) {
                    let j = new ListPanelTemplateWidthRequestedEventArgs();
                    j.c = c;
                    j.b = a;
                    j.a = i;
                    this.itemWidthRequested(this, j);
                    i = j.a;
                }
                let k = this.am._inner[a];
                this.am._inner[a] = i;
                let l = i - k;
                for (let m = a; m < this.actualDataSource.actualCount; m++) {
                    this.an._inner[m] += l;
                }
            }
            this.bz(a);
        }
        b9() {
            this.cp();
        }
        cc(a, b) {
            if (this.k == 0) {
                if (this.ai) {
                    let c = this.av;
                    if (this.itemHeightRequested != null) {
                        let d = new ListPanelTemplateHeightRequestedEventArgs();
                        d.c = b;
                        d.b = a;
                        d.a = c;
                        this.itemHeightRequested(this, d);
                        c = d.a;
                    }
                    this.ak.insert(a, c);
                    let e = 0;
                    if (a > 0) {
                        let f = this.al._inner[a - 1];
                        e = f + this.ak._inner[a - 1];
                    }
                    this.al.insert(a, e);
                    for (let g = a; g < this.actualDataSource.actualCount; g++) {
                        this.al._inner[g] += c;
                    }
                }
            }
            else {
                let h = 0;
                if (this.itemWidthRequested != null) {
                    let i = new ListPanelTemplateWidthRequestedEventArgs();
                    i.c = b;
                    i.b = a;
                    i.a = h;
                    this.itemWidthRequested(this, i);
                    h = i.a;
                }
                this.am.insert(a, h);
                let j = 0;
                if (a > 0) {
                    let k = this.an._inner[a - 1];
                    j = k + this.am._inner[a - 1];
                }
                this.an.insert(a, j);
                for (let l = a; l < this.actualDataSource.actualCount; l++) {
                    this.an._inner[l] += h;
                }
            }
            this.cj();
        }
        ce(a, b) {
            if (this.k == 0) {
                let c = this.ak._inner[a];
                for (let d = a + 1; d < this.actualDataSource.actualCount; d++) {
                    this.al._inner[d] -= c;
                }
                this.ak.removeAt(a);
                this.al.removeAt(a);
            }
            else {
                let e = this.am._inner[a];
                for (let f = a + 1; f < this.actualDataSource.actualCount; f++) {
                    this.an._inner[f] -= e;
                }
                this.am.removeAt(a);
                this.an.removeAt(a);
            }
            this.cj();
        }
        b7(a, b, c) {
            if (this.a != null) {
                this.a.notifySetItem(a, b, c);
            }
        }
        b4() {
            if (this.a != null) {
                this.a.notifyClearItems();
            }
        }
        b5(a, b) {
            if (this.a != null) {
                this.a.notifyInsertItem(a, b);
            }
            ;
        }
        b6(a, b) {
            if (this.a != null) {
                this.a.notifyRemoveItem(a, b);
            }
            ;
        }
        a3(a) {
            if (this.a == null) {
                return -1;
            }
            return this.a.indexOfItem(a);
        }
        a4(a) {
            if (this.a == null) {
                return -1;
            }
            return this.a.indexOfKey(a);
        }
        get cv() {
            return this.ct;
        }
        set cv(a) {
            let b = this.ct;
            this.ct = a;
            if (b != this.ct) {
                this.cd("BackgroundColor", b, a);
            }
        }
        get k() {
            return this.i;
        }
        set k(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.cd("Orientation", enumGetBox(ListPanelOrientation_$type, b), enumGetBox(ListPanelOrientation_$type, a));
            }
        }
        get ai() {
            return this.aa;
        }
        set ai(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.cd("IsCustomRowHeightEnabled", b, a);
            }
        }
        get cy() {
            return this.cu;
        }
        set cy(a) {
            let b = this.cu;
            this.cu = a;
            if (b != this.cu) {
                this.cd("TextColor", b, a);
            }
        }
        get au() {
            return this.aq;
        }
        get at() {
            return this.ap;
        }
    }
    ListPanel.$t = /*@__PURE__*/ markType(ListPanel, 'ListPanel', Base.$, [INotifyPropertyChanged_$type]);
    ListPanel.cw = /*@__PURE__*/ BrushUtil.h(255, 248, 248, 248);
    ListPanel.j = 0;
    ListPanel.af = false;
    ListPanel.cx = /*@__PURE__*/ BrushUtil.h(255, 24, 29, 31);
    return ListPanel;
})();
/**
 * @hidden
 */
export let ListPanelDataSourceNotificationBridge = /*@__PURE__*/ (() => {
    class ListPanelDataSourceNotificationBridge extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        rangeActualized(a, b) {
            this.a.ca(a, b);
        }
        notifySetItem(a, b, c) {
            this.a.cf(a, b, c);
        }
        notifyClearItems() {
            this.a.b9();
        }
        notifyInsertItem(a, b) {
            this.a.cc(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.ce(a, b);
        }
    }
    ListPanelDataSourceNotificationBridge.$t = /*@__PURE__*/ markType(ListPanelDataSourceNotificationBridge, 'ListPanelDataSourceNotificationBridge', Base.$, [IDataSourceUpdateNotifier_$type]);
    return ListPanelDataSourceNotificationBridge;
})();
/**
 * @hidden
 */
export let ListPanelLayoutPanel = /*@__PURE__*/ (() => {
    class ListPanelLayoutPanel extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        e(a) {
            this.a.ad = a.width;
            this.a.x = a.height;
        }
        b(a, b) {
            if (!b.e) {
                b.e = true;
                this.a.bj(b.a.a);
            }
            if (a.k == 0) {
                if (!isNaN_(a.au)) {
                    b.a.a.ad = a.au;
                }
                b.a.a.x = a.aw(b.m);
            }
            else {
                b.a.a.ad = a.ax(b.m);
                b.a.a.x = a.at;
            }
            if (b.g) {
                b.g = false;
                this.a.bq(b.a.a, b.j);
                this.a.br(b.a.a, b.l);
            }
        }
        c(a) {
            this.a.br(a, -1000);
            this.a.bq(a, -1000);
        }
        d(a) {
            a.j = -1000;
            a.l = -1000;
            if (a.a != null) {
                this.c(a.a.a);
            }
        }
    }
    ListPanelLayoutPanel.$t = /*@__PURE__*/ markType(ListPanelLayoutPanel, 'ListPanelLayoutPanel');
    return ListPanelLayoutPanel;
})();
