/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, runOn, delegateCombine, delegateRemove, EnumUtil, typeGetValue, enumGetBox, INotifyPropertyChanged_$type, PropertyChangedEventArgs, fromEn, fromEnum, typeCast, String_$type } from "igniteui-webcomponents-core";
import { INativeUIElementFactory_$type } from "igniteui-webcomponents-core";
import { NativeUIComponent } from "igniteui-webcomponents-core";
import { XComponentBridge } from "igniteui-webcomponents-inputs";
import { INativeUIToolPanelBridge_$type } from "./INativeUIToolPanelBridge";
import { Size } from "igniteui-webcomponents-core";
import { ToolCommandEventArgs } from "./ToolCommandEventArgs";
import { ToolPanelOrientation_$type } from "./ToolPanelOrientation";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { RenderingContext } from "igniteui-webcomponents-core";
import { DeviceUtils } from "igniteui-webcomponents-core";
import { DOMExecutionContext } from "igniteui-webcomponents-core";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { NativeUI } from "igniteui-webcomponents-core";
import { FontUtil } from "igniteui-webcomponents-core";
import { ToolbarOrientation_$type } from "./ToolbarOrientation";
import { ListPanel } from "./ListPanel";
import { List$1 } from "igniteui-webcomponents-core";
import { Popup } from "igniteui-webcomponents-core";
import { Rect } from "igniteui-webcomponents-core";
import { Brush } from "igniteui-webcomponents-core";
import { Visibility_$type } from "igniteui-webcomponents-core";
import { ToolActionType_$type } from "igniteui-webcomponents-core";
import { BrushUtil } from "igniteui-webcomponents-core";
import { ObservableCollection$1 } from "igniteui-webcomponents-core";
import { ToolActionEventDetail } from "./ToolActionEventDetail";
import { ToolCommandArgument } from "igniteui-webcomponents-core";
import { Thickness } from "igniteui-webcomponents-core";
import { CornerRadius } from "igniteui-webcomponents-core";
import { ToolActionMeasurementContext } from "./ToolActionMeasurementContext";
import { ToolActionEventDetailCollection } from "./ToolActionEventDetailCollection";
import { ToolActionPerformedEventArgs } from "./ToolActionPerformedEventArgs";
import { ToolCommand } from "igniteui-webcomponents-core";
import { CSSColorUtil } from "igniteui-webcomponents-core";
import { stringReplace, stringIsNullOrEmpty } from "igniteui-webcomponents-core";
import { isNaN_, isPositiveInfinity, truncate, tryParseNumber } from "igniteui-webcomponents-core";
import { ToolActionButtonDisplayType_$type } from "./ToolActionButtonDisplayType";
import { SvgIconRegistry } from "igniteui-webcomponents-core";
import { TooltipTextPresenter } from "./TooltipTextPresenter";
import { DelayManager } from "igniteui-webcomponents-core";
import { NativeUIWindow } from "igniteui-webcomponents-core";
import { NativeUIIconButton } from "igniteui-webcomponents-core";
import { BrushUtilCore } from "igniteui-webcomponents-core";
import { Color } from "igniteui-webcomponents-core";
import { ICommandStateChangedListener_$type } from "igniteui-webcomponents-core";
import { SRProvider } from "igniteui-webcomponents-core";
import { NativeUIInputsFactory } from "igniteui-webcomponents-core";
import { NativeUIXInputsFactory } from "igniteui-webcomponents-inputs";
import { ToolPanelContentRefreshedEventArgs } from "./ToolPanelContentRefreshedEventArgs";
import { Dictionary$2 } from "igniteui-webcomponents-core";
import { TranslateTransform } from "igniteui-webcomponents-core";
import { AnimationKeyFrameProperty } from "igniteui-webcomponents-core";
import { Queue$1 } from "igniteui-webcomponents-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-webcomponents-core";
import { AnimationKeyFrameEffect } from "igniteui-webcomponents-core";
import { KeyFrameAnimationFactory } from "igniteui-webcomponents-core";
import { MatrixTransform } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let NativeUILayoutFactory = /*@__PURE__*/ (() => {
    class NativeUILayoutFactory extends Base {
        constructor() {
            super(...arguments);
            this.c = 2;
        }
        static get b() {
            if (NativeUILayoutFactory.a == null) {
                NativeUILayoutFactory.a = new NativeUILayoutFactory();
            }
            return NativeUILayoutFactory.a;
        }
        static e() {
            NativeUIComponent.ap(NativeUILayoutFactory.b);
        }
        get flavor() {
            return this.c;
        }
        createComponent(a, b, c) {
            switch (b) {
                case 13:
                    this.d(a, c);
                    break;
            }
        }
        createComponentSync(a, b, c) {
            this.createComponent(a, b, c);
        }
        supportsComponent(a) {
            switch (a) {
                case 13: return true;
            }
            return false;
        }
        d(a, b) {
            let c = a;
            let d = c.createElement("div");
            let e = c.getSubRenderer(d);
            let f = new ToolPanel();
            f.provideContainer(e);
            let g = new XToolPanelBridge(f);
            let h = new NativeUIToolPanel();
            h.al = d;
            h.d = g;
            b(h);
        }
    }
    NativeUILayoutFactory.$t = /*@__PURE__*/ markType(NativeUILayoutFactory, 'NativeUILayoutFactory', Base.$, [INativeUIElementFactory_$type]);
    NativeUILayoutFactory.a = null;
    return NativeUILayoutFactory;
})();
/**
 * @hidden
 */
export let XToolPanelBridge = /*@__PURE__*/ (() => {
    class XToolPanelBridge extends XComponentBridge {
        constructor(a) {
            super(a);
            this.u = null;
            this.x = null;
            this.v = null;
            this.y = null;
            this.w = null;
            this.z = null;
        }
        getDesiredSize(a, b) {
            return this.t.f7();
        }
        addHandler(a, b, c, d) {
            let e = a;
            switch (c) {
                case 10:
                    e.drillDownRequested = delegateCombine(e.drillDownRequested, runOn(this, this.ab));
                    this.u = d;
                    this.x = b;
                    break;
                case 11:
                    e.drillUpRequested = delegateCombine(e.drillUpRequested, runOn(this, this.ac));
                    this.v = d;
                    this.y = b;
                    break;
                case 16:
                    e.onCommand = delegateCombine(e.onCommand, runOn(this, this.aa));
                    this.w = d;
                    this.z = b;
                    break;
            }
        }
        removeHandler(a, b, c, d) {
            let e = a;
            switch (c) {
                case 10:
                    e.drillDownRequested = delegateRemove(e.drillDownRequested, runOn(this, this.ab));
                    this.u = null;
                    this.x = null;
                    break;
                case 11:
                    e.drillUpRequested = delegateRemove(e.drillUpRequested, runOn(this, this.ac));
                    this.v = null;
                    this.y = null;
                    break;
                case 16:
                    e.onCommand = delegateRemove(e.onCommand, runOn(this, this.aa));
                    this.w = null;
                    this.z = null;
                    break;
            }
        }
        ab(a, b) {
            if (this.u != null) {
                this.u(this.x, b);
            }
        }
        ac(a, b) {
            if (this.v != null) {
                this.v(this.y, b);
            }
        }
        aa(a, b) {
            if (this.w != null) {
                this.w(this.z, b);
            }
        }
        setValue(a, b, c) {
            let d = a;
            switch (b) {
                case 27:
                    d.actions = c;
                    break;
                case 30:
                    d.o = EnumUtil.getEnumValue(ToolPanelOrientation_$type, c);
                    break;
                case 28:
                    d.bx = typeGetValue(c);
                    break;
                case 18:
                    d.r = EnumUtil.getEnumValue(BaseControlTheme_$type, c);
                    break;
                case 11:
                    d.v = c;
                    break;
            }
        }
        getValue(a, b) {
            let c = a;
            switch (b) {
                case 27: return c.actions;
                case 30: return enumGetBox(ToolPanelOrientation_$type, c.o);
                case 28: return c.bx;
                case 29: return c.ba;
                case 18: return enumGetBox(BaseControlTheme_$type, c.r);
                case 11: return c.v;
            }
            return null;
        }
        refresh(a) {
            a.ef();
        }
        notifySizeChanged(a, b) {
            a.notifySizeChanged();
        }
    }
    XToolPanelBridge.$t = /*@__PURE__*/ markType(XToolPanelBridge, 'XToolPanelBridge', XComponentBridge.$, [INativeUIToolPanelBridge_$type]);
    return XToolPanelBridge;
})();
/**
 * @hidden
 */
export let ToolbarView = /*@__PURE__*/ (() => {
    class ToolbarView extends Base {
        constructor() {
            super();
            this.o = null;
            this.n = null;
            this.g = DeviceUtils.g(44);
            this.a = null;
            this.j = null;
            this.m = null;
            this.e = null;
            this.l = null;
            this.b = ((() => {
                let $ret = new FontInfo();
                $ret.q = "Verdana";
                $ret.f = 13;
                $ret.t = "Normal";
                $ret.v = "Normal";
                $ret.r = "Normal";
                return $ret;
            })());
            this.ab = new Size();
            this.c = null;
            this._gridExternal = null;
            this.f = false;
            this.k = null;
        }
        q() {
            return this.j;
        }
        w() {
        }
        u(a) {
            if (a == null) {
                this.j = null;
                return;
            }
            this.a.c = new DOMExecutionContext(a);
            this.j = a;
            this.m = this.j.createElement("canvas");
            this.e = new RenderingContext(new CanvasViewRenderer(), this.j.get2DCanvasContext(this.m));
            this.l = this.j.createElement("div");
            this.z();
            let b = new ToolPanel();
            let c = this.j.createElement("div");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("height", "100%");
            this.j.append(c);
            let d = this.j.getSubRenderer(c);
            b.provideContainer(d);
            let e = this.j.getExternal(b, this.j.rootWrapper, this.j.getExternal(this.a, null, null));
            this.a.ck(b);
            let f = Math.round(a.rootWrapper.width());
            let g = Math.round(a.rootWrapper.height());
            this.j.rootWrapper.setStyleProperty("position", "relative");
        }
        z() {
        }
        y() {
            if (this.j != null) {
            }
        }
        t() {
            if (this.j == null) {
                return;
            }
            let a = this.j.rootWrapper.width();
            let b = this.j.rootWrapper.height();
            if (!this.a.userSetWidth && this.a.l == 0) {
                this.j.rootWrapper.setStyleProperty("width", this.g + "px");
                a = this.g;
            }
            this.ab = new Size(1, a, b);
            this.a.cn(this.ab);
        }
        aa() {
            let a = this.j;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.q(b, this.a.dp);
                NativeUI.m(b, this.a.de);
            }
        }
        d() {
            return this.b;
        }
        v() {
        }
        x() {
        }
        s() {
        }
        h() {
            return this.ab.width;
        }
        i(a) {
            this.c = this.a.v();
            return FontUtil.measureStringWidth(a, this.c, this.e);
        }
        r(a, b) {
            if (this.k == null) {
                this.k = this.j.createElement("div");
            }
            b(this.k.getNativeElement());
        }
    }
    ToolbarView.$t = /*@__PURE__*/ markType(ToolbarView, 'ToolbarView');
    return ToolbarView;
})();
/**
 * @hidden
 */
export let ToolPanelView = /*@__PURE__*/ (() => {
    class ToolPanelView extends Base {
        constructor() {
            super();
            this.s = null;
            this.r = null;
            this.c = null;
            this.n = null;
            this.q = null;
            this.g = null;
            this.p = null;
            this.d = ((() => {
                let $ret = new FontInfo();
                $ret.q = "Verdana";
                $ret.f = 13;
                $ret.t = "Normal";
                $ret.v = "Normal";
                $ret.r = "Normal";
                return $ret;
            })());
            this.ai = new Size();
            this.e = null;
            this._gridExternal = null;
            this.h = false;
            this.o = null;
        }
        v() {
            return this.n;
        }
        ac() {
        }
        get t() {
            return this.n.rootWrapper;
        }
        aa(a) {
            if (a == null) {
                this.n = null;
                return;
            }
            this.c.a = new DOMExecutionContext(a);
            this.n = a;
            this.q = this.n.createElement("canvas");
            this.g = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.q));
            this.p = this.n.createElement("div");
            this.af();
            let b = new ListPanel();
            let c = this.n.createElement("div");
            c.setStyleProperty("width", "100%");
            c.setStyleProperty("height", "100%");
            this.n.append(c);
            let d = this.n.getSubRenderer(c);
            b.provideContainer(d);
            let e = this.n.getExternal(b, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            b.externalListPanel = e;
            this.c.d1(b);
            let f = Math.round(a.rootWrapper.width());
            let g = Math.round(a.rootWrapper.height());
            this.n.rootWrapper.setStyleProperty("position", "relative");
            this.n.rootWrapper.setStyleProperty("width", "100%");
            this.ad();
        }
        af() {
        }
        y() {
            if (this.n == null) {
                return;
            }
            let a = this.n.rootWrapper.width();
            let b = this.n.rootWrapper.height();
            this.ai = new Size(1, a, b);
            this.c.d6(this.ai);
            if (this.c.x != null) {
            }
        }
        k() {
            let a = this.n.rootWrapper.getNativeElement();
            return a.offsetWidth;
        }
        j() {
            let a = this.n.rootWrapper.getNativeElement();
            return a.offsetHeight;
        }
        ag() {
            let a = this.n;
            if (null == a) {
                return;
            }
            let b = a.rootWrapper;
            if (null != b) {
                NativeUI.q(b, this.c.f4);
                NativeUI.m(b, this.c.ft);
            }
        }
        f() {
            return this.d;
        }
        ab() {
        }
        ae() {
        }
        ad() {
            if (this.c.actions.count > 0 && this.c.o == 0) {
                this.n.rootWrapper.setStyleProperty("min-width", DeviceUtils.g(44) + "px");
            }
            else {
                this.n.rootWrapper.setStyleProperty("min-width", "0px");
            }
        }
        z() {
            this.ad();
        }
        x() {
        }
        i() {
            return this.ai.width;
        }
        l(a) {
            this.e = this.c.w();
            return FontUtil.measureStringWidth(a, this.e, this.g);
        }
        m(a, b) {
            return FontUtil.measureStringWidth(a, b, this.g);
        }
        w(a, b) {
            if (this.o == null) {
                this.o = this.n.createElement("div");
            }
            b(this.o.getNativeElement());
        }
        a() {
            let a = new Popup();
            let b = this.n.getExternal(a, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            return a;
        }
        b(a) {
            let b = new ToolPanel();
            let c = this.n.getExternal(b, this.n.rootWrapper, this.n.getExternal(this.c, null, null));
            let d = a.al;
            d.appendChild(b.p.n.rootWrapper.getNativeElement());
            return b;
        }
        ah(a) {
            let ele_ = a;
            let bounds_ = (ele_.getBoundingClientRect());
            let b = bounds_["left"];
            let c = bounds_["top"];
            let d = bounds_["width"];
            let e = bounds_["height"];
            return new Rect(0, b, c, d, e);
        }
    }
    ToolPanelView.$t = /*@__PURE__*/ markType(ToolPanelView, 'ToolPanelView');
    return ToolPanelView;
})();
/**
 * @hidden
 */
export let NativeUIToolPanel = /*@__PURE__*/ (() => {
    class NativeUIToolPanel extends NativeUIComponent {
        constructor() {
            super(...arguments);
            this.bl = null;
            this.bg = null;
            this.bh = null;
            this.bn = null;
        }
        get bk() {
            return this.d;
        }
        get bp() {
            return this.ae(27);
        }
        set bp(a) {
            this.a0(27, a);
        }
        get bt() {
            return this.ae(28);
        }
        set bt(a) {
            this.a0(28, a);
        }
        get bs() {
            return this.ae(29);
        }
        get bq() {
            return EnumUtil.getEnumValue(ToolPanelOrientation_$type, this.ae(30));
        }
        set bq(a) {
            this.a0(30, enumGetBox(ToolPanelOrientation_$type, a));
        }
        get b2() {
            return this.ae(33);
        }
        set b2(a) {
            this.a0(33, a);
        }
        get bx() {
            return this.ae(34);
        }
        set bx(a) {
            this.a0(34, a);
        }
        get bw() {
            return this.ae(23);
        }
        set bw(a) {
            this.a0(23, a);
        }
        get b1() {
            return this.ae(50);
        }
        set b1(a) {
            this.a0(50, a);
        }
        get by() {
            return this.ae(51);
        }
        set by(a) {
            this.a0(51, a);
        }
        get bz() {
            return this.ae(52);
        }
        set bz(a) {
            this.a0(52, a);
        }
        get b0() {
            return this.ae(53);
        }
        set b0(a) {
            this.a0(53, a);
        }
        get br() {
            return this.ae(11);
        }
        set br(a) {
            this.a0(11, a);
        }
        get bm() {
            return this.bl;
        }
        set bm(a) {
            let b = this.bl;
            this.bl = a;
            if (this.bl != null) {
                this.an(9, this.bl);
            }
            else {
                this.ay(9, b);
            }
        }
        get bi() {
            return this.bg;
        }
        set bi(a) {
            let b = this.bg;
            this.bg = a;
            if (this.bg != null) {
                this.an(10, this.bg);
            }
            else {
                this.ay(10, b);
            }
        }
        get bj() {
            return this.bh;
        }
        set bj(a) {
            let b = this.bh;
            this.bh = a;
            if (this.bh != null) {
                this.an(11, this.bh);
            }
            else {
                this.ay(11, b);
            }
        }
        get bo() {
            return this.bn;
        }
        set bo(a) {
            let b = this.bn;
            this.bn = a;
            if (this.bn != null) {
                this.an(16, this.bn);
            }
            else {
                this.ay(16, b);
            }
        }
        bv() {
            this.bk.refresh(this.ak);
        }
        bu(a) {
            this.bk.notifySizeChanged(this.ak, a);
        }
    }
    NativeUIToolPanel.$t = /*@__PURE__*/ markType(NativeUIToolPanel, 'NativeUIToolPanel', NativeUIComponent.$);
    return NativeUIToolPanel;
})();
/**
 * @hidden
 */
export let ToolAction = /*@__PURE__*/ (() => {
    class ToolAction extends Base {
        e5(a) {
            this.n = a;
            if (this.n != null) {
                if (this.w != null && this.n.p.n != null) {
                    this.w.w(this.n.p.n);
                }
            }
        }
        get f() {
            return this.e;
        }
        set f(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.ev("ExecutionContext", b, this.e);
            }
        }
        get dk() {
            if (this.dn != null) {
                return this.dn;
            }
            if (this.d4 != null) {
                return this.dz(this.d4);
            }
            return null;
        }
        get actions() {
            return this.i;
        }
        get b0() {
            return this.bd;
        }
        set b0(a) {
            this.bd = a;
        }
        constructor() {
            super();
            this.n = null;
            this.e = null;
            this.h = null;
            this.i = new ToolActionCollection();
            this.bd = NaN;
            this.ca = null;
            this.cu = null;
            this.cr = null;
            this.dq = null;
            this.b6 = null;
            this.b5 = null;
            this.b1 = null;
            this.o = 0;
            this.a9 = NaN;
            this.ay = NaN;
            this.ba = NaN;
            this.az = NaN;
            this.a8 = NaN;
            this.ax = NaN;
            this.bb = NaN;
            this.a0 = NaN;
            this.fe = null;
            this.fm = null;
            this.fj = BrushUtil.h(0, 0, 0, 0);
            this.fb = null;
            this.fi = null;
            this.fh = null;
            this.fp = null;
            this.fc = null;
            this.fk = null;
            this.r = null;
            this.t = null;
            this.af = false;
            this.ag = false;
            this.b9 = null;
            this.cc = null;
            this.cb = null;
            this.bc = 30;
            this.b8 = null;
            this.b7 = null;
            this.a5 = NaN;
            this.a6 = NaN;
            this.a7 = NaN;
            this.a4 = NaN;
            this.fn = null;
            this.ff = null;
            this.a = null;
            this.fo = null;
            this.fg = null;
            this.b = null;
            this.a3 = NaN;
            this.f4 = 0;
            this.ae = false;
            this.a2 = NaN;
            this.aw = NaN;
            this.a1 = NaN;
            this.av = NaN;
            this.fl = null;
            this.fd = null;
            this.propertyChanged = null;
            this.s = ((() => {
                let $ret = new FontInfo();
                $ret.q = "Verdana";
                $ret.f = 13;
                $ret.t = "Normal";
                $ret.v = "Normal";
                $ret.r = "Normal";
                return $ret;
            })());
            this.onCommand = null;
            this.performed = null;
            this.aa = null;
            this.z = null;
            this.x = null;
            this.ac = null;
            this.ad = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.em));
            let b = this.actions;
            b.collectionResetting = delegateCombine(b.collectionResetting, runOn(this, this.en));
        }
        d8() {
        }
        em(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    c.d8();
                    c.h = null;
                    let d = c;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.ep));
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    e.h = this;
                    let f = e;
                    f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.ep));
                }
            }
        }
        en(a, b) {
            for (let c of fromEnum(this.actions)) {
                c.d8();
                c.h = null;
            }
        }
        ep(a, b) {
            this.d7(a, b.propertyName);
        }
        d7(a, b) {
            if (this.h != null) {
                this.h.d7(a, b);
            }
        }
        dz(a) {
            return stringReplace(a, " ", "_");
        }
        k(a) {
            return ((() => {
                let $ret = new ToolActionEventDetail();
                $ret.g = this.dk;
                $ret.a = this.q;
                $ret.c = a;
                return $ret;
            })());
        }
        ek(a) {
            if (this.cw != null || this.b2 != null) {
                a.add(((() => {
                    let $ret = new ToolCommandArgument();
                    $ret.argumentName = this.dx();
                    $ret.value = this.b3();
                    return $ret;
                })()));
            }
            this.el(a);
        }
        el(a) {
        }
        dx() {
            if (this.cw != null) {
                return this.cw;
            }
            return this.dk != null ? this.dk : "Unknown";
        }
        b3() {
            if (this.b2 != null) {
                return this.b2;
            }
            return this.b4();
        }
        b4() {
            return null;
        }
        get dv() {
            return this.ca;
        }
        set dv(a) {
            let b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.ev("ParentId", b, this.ca);
            }
        }
        dy() {
            if (this.cz != null) {
                return this.cz;
            }
            return this.dk;
        }
        get cz() {
            return this.b6;
        }
        set cz(a) {
            let b = this.b6;
            this.b6 = a;
            if (b != this.b6) {
                this.ev("CommandId", b, this.b6);
            }
        }
        get cw() {
            return this.b5;
        }
        set cw(a) {
            let b = this.b5;
            this.b5 = a;
            if (b != this.b5) {
                this.ev("CommandArgument", b, this.b5);
            }
        }
        get b2() {
            return this.b1;
        }
        set b2(a) {
            let b = this.b1;
            this.b1 = a;
            if (b != this.b1) {
                this.ev("CommandArgumentValue", b, this.b1);
            }
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.ev("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get bw() {
            return this.a9;
        }
        set bw(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.ev("PaddingLeft", b, this.a9);
            }
        }
        get bh() {
            return this.ay;
        }
        set bh(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.ev("ActualPaddingLeft", b, this.ay);
            }
        }
        get bx() {
            return this.ba;
        }
        set bx(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.ev("PaddingRight", b, this.ba);
            }
        }
        get bi() {
            return this.az;
        }
        set bi(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.ev("ActualPaddingRight", b, this.az);
            }
        }
        get bv() {
            return this.a8;
        }
        set bv(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.ev("PaddingBottom", b, this.a8);
            }
        }
        get bg() {
            return this.ax;
        }
        set bg(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.ev("ActualPaddingBottom", b, this.ax);
            }
        }
        get by() {
            return this.bb;
        }
        set by(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.ev("PaddingTop", b, this.bb);
            }
        }
        get bj() {
            return this.a0;
        }
        set bj(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.ev("ActualPaddingTop", b, this.a0);
            }
        }
        get ft() {
            return this.fe;
        }
        set ft(a) {
            let b = this.fe;
            this.fe = a;
            if (b != this.fe) {
                this.ev("ActualHoverBackground", b, this.fe);
            }
        }
        get f0() {
            return this.fm;
        }
        set f0(a) {
            let b = this.fm;
            this.fm = a;
            if (b != this.fm) {
                this.ev("HoverBackground", b, this.fm);
            }
        }
        get fq() {
            return this.fb;
        }
        set fq(a) {
            let b = this.fb;
            this.fb = a;
            if (b != this.fb) {
                this.ev("ActualBackground", b, this.fb);
            }
        }
        get fx() {
            return this.fi;
        }
        set fx(a) {
            let b = this.fi;
            this.fi = a;
            if (b != this.fi) {
                this.ev("Background", b, this.fi);
            }
        }
        get fw() {
            return this.fh;
        }
        set fw(a) {
            let b = this.fh;
            this.fh = a;
            if (b != this.fh) {
                this.ev("ActualTextColor", b, this.fh);
            }
        }
        get f3() {
            return this.fp;
        }
        set f3(a) {
            let b = this.fp;
            this.fp = a;
            if (b != this.fp) {
                this.ev("TextColor", b, this.fp);
            }
        }
        get fr() {
            return this.fc;
        }
        set fr(a) {
            let b = this.fc;
            this.fc = a;
            if (b != this.fc) {
                this.ev("ActualDisabledTextColor", b, this.fc);
            }
        }
        get fy() {
            return this.fk;
        }
        set fy(a) {
            let b = this.fk;
            this.fk = a;
            if (b != this.fk) {
                this.ev("DisabledTextColor", b, this.fk);
            }
        }
        get u() {
            return this.r;
        }
        set u(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.ev("ActualTextStyle", b, this.r);
            }
        }
        get w() {
            return this.t;
        }
        set w(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.ev("TextStyle", b, this.t);
            }
        }
        get an() {
            return this.af;
        }
        set an(a) {
            let b = this.af;
            this.af = a;
            if (b != this.af) {
                this.ev("IsDisabled", b, this.af);
            }
        }
        get ao() {
            return this.ag;
        }
        set ao(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.ev("IsHighlighted", b, this.ag);
            }
        }
        get am() {
            return this.dv != null;
        }
        get dn() {
            return this.b9;
        }
        set dn(a) {
            let b = this.b9;
            this.b9 = a;
            if (b != this.b9) {
                this.ev("Name", b, this.b9);
            }
        }
        get d4() {
            return this.cc;
        }
        set d4(a) {
            let b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.ev("Title", b, this.cc);
            }
        }
        get d0() {
            return this.cb;
        }
        set d0(a) {
            let b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.ev("Subtitle", b, this.cb);
            }
        }
        get_bz() {
            return this.bc;
        }
        get bz() {
            return this.get_bz();
        }
        get db() {
            return this.b8;
        }
        set db(a) {
            let b = this.b8;
            this.b8 = a;
            if (b != this.b8) {
                this.ev("IconName", b, this.b8);
            }
        }
        get c7() {
            return this.b7;
        }
        set c7(a) {
            let b = this.b7;
            this.b7 = a;
            if (b != this.b7) {
                this.ev("IconCollectionName", b, this.b7);
            }
        }
        get bs() {
            return this.a5;
        }
        set bs(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.ev("IconViewBoxLeft", b, this.a5);
            }
        }
        get bt() {
            return this.a6;
        }
        set bt(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.ev("IconViewBoxTop", b, this.a6);
            }
        }
        get bu() {
            return this.a7;
        }
        set bu(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.ev("IconViewBoxWidth", b, this.a7);
            }
        }
        get br() {
            return this.a4;
        }
        set br(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.ev("IconViewBoxHeight", b, this.a4);
            }
        }
        get f1() {
            return this.fn;
        }
        set f1(a) {
            let b = this.fn;
            this.fn = a;
            if (b != this.fn) {
                this.ev("IconFill", b, this.fn);
            }
        }
        get fu() {
            return this.ff;
        }
        set fu(a) {
            let b = this.ff;
            this.ff = a;
            if (b != this.ff) {
                this.ev("ActualIconFill", b, this.ff);
            }
        }
        get c() {
            return this.a;
        }
        set c(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.ev("IconFillColors", b, this.a);
            }
        }
        get f2() {
            return this.fo;
        }
        set f2(a) {
            let b = this.fo;
            this.fo = a;
            if (b != this.fo) {
                this.ev("IconStroke", b, this.fo);
            }
        }
        get fv() {
            return this.fg;
        }
        set fv(a) {
            let b = this.fg;
            this.fg = a;
            if (b != this.fg) {
                this.ev("ActualIconStroke", b, this.fg);
            }
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.ev("IconStrokeColors", b, this.b);
            }
        }
        get bq() {
            return this.a3;
        }
        set bq(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.ev("IconStrokeWidth", b, this.a3);
            }
        }
        get f5() {
            return this.f4;
        }
        set f5(a) {
            let b = this.f4;
            this.f4 = a;
            if (b != this.f4) {
                this.ev("Visibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.f4));
            }
        }
        get ai() {
            return this.ae;
        }
        set ai(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.ev("CloseOnExecute", b, this.ae);
            }
        }
        get bp() {
            return this.a2;
        }
        set bp(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.ev("HighlightWidth", b, this.a2);
            }
        }
        get bf() {
            return this.aw;
        }
        set bf(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.ev("ActualHighlightWidth", b, this.aw);
            }
        }
        get bo() {
            return this.a1;
        }
        set bo(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.ev("HighlightRadius", b, this.a1);
            }
        }
        get be() {
            return this.av;
        }
        set be(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.ev("ActualHighlightRadius", b, this.av);
            }
        }
        get fz() {
            return this.fl;
        }
        set fz(a) {
            let b = this.fl;
            this.fl = a;
            if (b != this.fl) {
                this.ev("HighlightColor", b, this.fl);
            }
        }
        get fs() {
            return this.fd;
        }
        set fs(a) {
            let b = this.fd;
            this.fd = a;
            if (b != this.fd) {
                this.ev("ActualHighlightColor", b, this.fd);
            }
        }
        get_aj() {
            return true;
        }
        get aj() {
            return this.get_aj();
        }
        get_ak() {
            return true;
        }
        get ak() {
            return this.get_ak();
        }
        get_aq() {
            return true;
        }
        get aq() {
            return this.get_aq();
        }
        get_as() {
            return true;
        }
        get as() {
            return this.get_as();
        }
        get_ah() {
            return true;
        }
        get ah() {
            return this.get_ah();
        }
        eq() {
            if (this.h == null) {
                return;
            }
            this.h.eq();
        }
        ev(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.e2(a, b, c);
        }
        get_q() {
            return 0;
        }
        get q() {
            return this.get_q();
        }
        e2(a, b, c) {
            switch (a) {
                case "TextStyle":
                    if (this.w != null && this.n != null && this.n.p.n != null) {
                        this.w.w(this.n.p.n);
                    }
                    this.e9();
                    break;
                case "Background":
                case "TextColor":
                case "IconFill":
                case "IconStroke":
                    this.e9();
                    break;
                case "ActualBackground":
                    if (this.ab != null) {
                        this.ab.a4 = this.fq;
                    }
                    break;
                case "ActualTextColor":
                    if (this.ad != null) {
                        this.ad.a6 = this.fw;
                    }
                    break;
                case "ActualTextStyle":
                    if (this.ad != null) {
                        this.ad.bg = this.u;
                    }
                    break;
                case "IsDisabled":
                    if (this.ad != null) {
                        this.ad.a6 = this.an ? this.fr : this.fw;
                    }
                    break;
                case "ActualIconFill":
                case "ActualIconStroke":
                case "IconFillColors":
                case "IconStrokeColors":
                    if (this.ac != null) {
                        this.ac.a7 = this.fu;
                        this.ac.a8 = this.fv;
                        this.ac.bg = this.c;
                        this.ac.bh = this.d;
                    }
                    break;
                case "Visibility":
                    if (this.n != null) {
                        this.n.eg();
                    }
                    break;
                case "IconName":
                case "IconCollectionName":
                    this.eu();
                    break;
                case "IsHighlighted":
                    this.e7(this.ab);
                    break;
            }
        }
        e7(a) {
            if (a != null) {
                if (this.ao) {
                    a.bc = new Thickness(0, DeviceUtils.g(this.bf));
                    a.a3 = new CornerRadius(0, DeviceUtils.g(this.be));
                }
                else {
                    a.bc = new Thickness(0, DeviceUtils.g(0));
                    a.a3 = new CornerRadius(0, DeviceUtils.g(0));
                }
                a.a5 = this.fs;
            }
        }
        ap() {
            return this.n != null && this.n.by != null && typeCast(Toolbar.$, this.n.by) !== null;
        }
        e9() {
            if (this.n == null) {
                return;
            }
            this.p = this.n.r;
            this.fq = this.fx != null ? this.fx : this.fj;
            this.fw = this.f3 != null ? this.f3 : this.n.fq;
            this.fr = this.fy != null ? this.fy : this.n.fg;
            this.ft = this.f0 != null ? this.f0 : this.n.fl;
            this.fu = this.f1 != null ? this.f1 : this.n.fm;
            this.fv = this.f2 != null ? this.f2 : this.n.fn;
            if (this.ac != null) {
                this.ac.bg = this.c;
                this.ac.bh = this.d;
            }
            this.u = this.w != null ? this.w : this.n.u;
            this.bh = !isNaN_(this.bw) ? this.bw : DeviceUtils.g(12);
            this.bi = !isNaN_(this.bx) ? this.bx : DeviceUtils.g(12);
            this.bj = !isNaN_(this.by) ? this.by : DeviceUtils.g(2);
            this.bg = !isNaN_(this.bv) ? this.bv : DeviceUtils.g(2);
            this.bf = !isNaN_(this.bp) ? this.bp : this.n.a9;
            this.be = !isNaN_(this.bo) ? this.bo : this.n.a8;
            this.fs = this.fz != null ? this.fz : this.n.fk;
            this.fa();
        }
        fa() {
        }
        eu() {
            if (this.ac != null) {
                this.ac.bn = this.db;
                this.ac.bm = this.c7;
            }
        }
        ex(a, b, c, d) {
            this.ei(c.b, c, d, (e) => {
                this.d9(c.b);
                this.aa = e;
                this.eh(c.b, this.aa, d, () => {
                    c.b.bo = this.aa;
                    this.e6(this.z, this.ac, this.ad);
                    this.ez(this.z == null ? this.aa : this.z, c, d);
                });
            });
        }
        ez(a, b, c) {
        }
        ey(a, b, c, d) {
        }
        ed(a, b) {
            this.ee(a, b);
        }
        ee(a, b) {
            b.f = this.bl(a, b);
            b.h = this.bn(a, b);
            b.g = this.bm(a, b);
            b.b = this.bk(a, b);
            if (b.a == 1) {
                let c = 0;
                if (!isNaN_(b.f)) {
                    c += b.f;
                }
                if (!isNaN_(b.h)) {
                    c += b.h;
                }
                if (!isNaN_(b.g)) {
                    c += b.g;
                }
                if (!isNaN_(b.b)) {
                    c += b.b;
                }
                c += (this.bh + this.bi);
                b.e = c;
            }
            else {
                if (!isNaN_(this.b0)) {
                    b.e = this.b0;
                }
                else {
                    let d = 0;
                    if (!isNaN_(b.f)) {
                        d += b.f;
                    }
                    if (!isNaN_(b.h)) {
                        d += b.h;
                    }
                    if (!isNaN_(b.g)) {
                        d += b.g;
                    }
                    if (!isNaN_(b.b)) {
                        d += b.b;
                    }
                    d += (this.bh + this.bi);
                    if (isNaN_(b.c) || isPositiveInfinity(b.c) || d > b.c) {
                        b.e = d;
                    }
                    else {
                        b.e = b.c;
                    }
                }
            }
        }
        bm(a, b) {
            return NaN;
        }
        bn(a, b) {
            if (this.d4 == null) {
                return NaN;
            }
            let c = this.v(a);
            let d = a.p.m(this.d4, c);
            return d + this.bz;
        }
        bl(a, b) {
            if (!stringIsNullOrEmpty(this.db)) {
                return DeviceUtils.g(36);
            }
            return NaN;
        }
        v(a) {
            if (this.w != null) {
                return this.w;
            }
            return a.w();
        }
        bk(a, b) {
            return NaN;
        }
        ew(a, b) {
            this.e3();
            if (this.am) {
                let c = this.n.f(this.dv);
                if (c != null) {
                    c.er(this, this.ai);
                }
            }
            else {
                if (this.n.ad(this)) {
                    if (this.performed != null) {
                        let d = new ToolActionEventDetailCollection();
                        this.ec(this, d, b);
                        this.performed(this, ((() => {
                            let $ret = new ToolActionPerformedEventArgs();
                            $ret.c = true;
                            $ret.b = d;
                            return $ret;
                        })()));
                    }
                }
                else {
                    if (this.performed != null) {
                        this.performed(this, ((() => {
                            let $ret = new ToolActionPerformedEventArgs();
                            $ret.c = false;
                            $ret.a = a;
                            return $ret;
                        })()));
                    }
                }
            }
        }
        e3() {
            let a = this.dy();
            if (a == null) {
                return;
            }
            let b = new ToolCommand();
            b.commandId = a;
            let c = new List$1(ToolCommandArgument.$, 0);
            this.eb(this, c);
            b.argumentsList = c.toArray();
            let d = ((() => {
                let $ret = new ToolCommandEventArgs();
                $ret.a = b;
                $ret.b = this.ai;
                return $ret;
            })());
            if (this.onCommand != null) {
                this.onCommand(this, d);
            }
            if (this.n != null) {
                this.n.d8(this, d);
            }
        }
        e4(a) {
            let b = ((() => {
                let $ret = new ToolCommandEventArgs();
                $ret.a = a;
                $ret.b = this.ai;
                return $ret;
            })());
            if (this.onCommand != null) {
                this.onCommand(this, b);
            }
            if (this.n != null) {
                this.n.d8(this, b);
            }
        }
        at() {
            return this.onCommand != null;
        }
        eb(a, b) {
            a.ek(b);
            let c = this.n.ai(a);
            if (c != null) {
                for (let d = 0; d < c.count; d++) {
                    if (c._inner[d].al()) {
                        this.eb(c._inner[d], b);
                    }
                }
            }
        }
        al() {
            return true;
        }
        er(a, b) {
            if (this.am) {
                let c = this.n.f(this.dv);
                if (c != null) {
                    c.er(a, b);
                }
            }
            else {
                this.ew(this.k(false), a);
                if (b) {
                    this.ea();
                }
            }
        }
        ec(a, b, c) {
            let d = a.k(a == c);
            b.add(d);
            let e = this.n.ai(a);
            if (e != null) {
                for (let f = 0; f < e.count; f++) {
                    this.ec(e._inner[f], b, c);
                }
            }
        }
        static g(a) {
            let b = null;
            switch (a.b) {
                case 2:
                    b = new ToolActionCheckbox();
                    break;
                case 1:
                    b = new ToolActionGroupHeader();
                    break;
                case 3:
                    b = new ToolActionIconButton();
                    break;
                case 4:
                    b = new ToolActionLabel();
                    break;
                case 5:
                    b = new ToolActionNumberInput();
                    break;
                case 6:
                    b = new ToolActionRadio();
                    break;
                case 7:
                    b = new ToolActionSeparator();
                    break;
                case 8:
                    b = new ToolActionIconMenu();
                    break;
                case 9:
                    b = new ToolActionButton();
                    break;
                case 10:
                    b = new ToolActionSubPanel();
                    break;
                case 0: return null;
            }
            b.ej(a);
            return b;
        }
        ej(a) {
            this.dn = a.name;
            this.d4 = a.title;
            this.cw = a.commandArgument;
            this.b2 = a.commandArgumentValue;
            this.cz = a.commandId;
            this.db = a.iconName;
            this.c7 = a.iconCollectionName;
            this.bs = a.iconViewBoxLeft;
            this.bt = a.iconViewBoxTop;
            this.bu = a.iconViewBoxWidth;
            this.br = a.iconViewBoxHeight;
            this.bw = a.paddingLeft;
            this.bx = a.paddingRight;
            this.by = a.paddingTop;
            this.bv = a.paddingBottom;
            this.dv = a.parentId;
            this.an = a.isDisabled;
            this.ai = a.closeOnExecute;
            if (!stringIsNullOrEmpty(a.textColor)) {
                this.f3 = CSSColorUtil.g(a.textColor);
            }
            if (!stringIsNullOrEmpty(a.disabledTextColor)) {
                this.fy = CSSColorUtil.g(a.disabledTextColor);
            }
            this.ao = a.isHighlighted;
            if (a.actions != null && a.actions.length > 0) {
                for (let b = 0; b < a.actions.length; b++) {
                    this.actions.add(ToolAction.g(a.actions[b]));
                }
            }
        }
        ar() {
            return this.h != null && this.h.h != null && this.h.actions._inner[0] == this;
        }
        au() {
            return true;
        }
        y(a) {
            switch (a) {
                case 1:
                case 6:
                case 11:
                case 10:
                case 2:
                case 12:
                case 13: return this.au() ? 2 : 0;
                default: return 0;
            }
        }
        get ab() {
            return this.aa;
        }
        ei(a, b, c, d) {
            if (a.bo == null || a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                NativeUIComponent.ar(this.n.p.v(), 7, (e) => {
                    let f = e;
                    this.eg(f, c);
                    this.e8(f, b, c);
                    if (d != null) {
                        d(f);
                    }
                });
            }
            else {
                let e = a.bo;
                this.e8(e, b, c);
                if (d != null) {
                    d(e);
                }
            }
        }
        eh(a, b, c, d) {
            if (a.bo == null || a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                let e = [1, 7, 11, 3];
                let f = [this.y(1), this.y(7), this.y(11), this.y(3)];
                NativeUIComponent.as(this.n.p.v(), e, f, (g) => {
                    let h = g[0];
                    let i = g[1];
                    let j = g[2];
                    let k = g[3];
                    this.ef(h, i, j, k, c);
                    if (d != null) {
                        d();
                    }
                });
            }
            else {
                this.e6(this.z, this.ac, this.ad);
                if (d != null) {
                    d();
                }
            }
        }
        eg(a, b) {
            a.f = b.a == 1 ? 0 : 3;
            a.bo = 0;
        }
        e8(a, b, c) {
            a.x = b.a.k;
            a.ad = c.e;
            a.a4 = this.fq;
            a.bf = this.f5;
            this.e7(a);
        }
        ef(a, b, c, d, e) {
            if (this.aa.bi == 0) {
                this.aa.bw(0, 2, 1);
                this.aa.by(0, 2, 1);
                this.aa.bj(a);
                this.aa.b3(a, 0);
                this.aa.b4(a, 0);
                a.bk = b;
                b.bo = 0;
                let f = this.bl(this.n, e);
                f = isNaN_(f) ? 0 : f;
                let g = this.bn(this.n, e);
                g = isNaN_(g) ? 0 : g - this.bz;
                b.by(0, 2, 1);
                b.bw(0, 1, f);
                b.bw(1, 1, g);
                b.bx(2, 2, 1, this.bz);
                b.bj(c);
                b.bj(d);
                b.b4(d, 0);
                b.b3(c, 0);
                b.b3(d, 1);
            }
            a.c = this.p;
            a.bl = 1;
            a.bj = 1;
            a.bw = new Thickness(1, 0, 0, 0, 0);
            a.g = 3;
            a.i = 3;
            a.bv = this.ft;
            a.br = true;
            a.bp = !this.aj;
            a.bm = this.ah;
            a.bo = !this.ak;
            a.bq = true;
            a.bn = true;
            a.bi = runOn(this, this.eo);
            c.h = 1;
            c.f = 1;
            d.bh = false;
            d.h = 1;
            d.f = 0;
            this.z = b;
            this.x = a;
            this.ac = c;
            this.ad = d;
        }
        eo(a, b) {
            this.et();
        }
        e6(a, b, c) {
            if (a != null) {
                a.be = new Thickness(1, this.bh, this.bj, this.bi, this.bg);
            }
            if (b != null) {
                b.bd = new Thickness(1, 0, 0, 9, 0);
                b.bj = this.bs;
                b.bk = this.bt;
                b.bl = this.bu;
                b.bi = this.br;
                b.bn = this.db;
                b.bm = this.c7;
                b.a7 = this.fu;
                b.bg = this.c;
                b.a8 = this.fv;
                b.bh = this.d;
                b.ab = this.bq;
                b.ad = 28;
                b.x = 28;
            }
            if (c != null) {
                c.bi = this.d4;
                c.bg = this.u;
                c.a6 = this.an ? this.fr : this.fw;
            }
        }
        d9(a) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                if (this.aa != null) {
                    this.aa.bq = null;
                }
            }
        }
        et() {
        }
        es(a, b) {
        }
        e0() {
        }
        ea() {
        }
        e1(a) {
            if (!stringIsNullOrEmpty(a.d4)) {
                this.d4 = a.d4;
            }
            if (!stringIsNullOrEmpty(a.d0)) {
                this.d0 = a.d0;
            }
            if (!stringIsNullOrEmpty(a.db)) {
                this.db = a.db;
            }
            if (!stringIsNullOrEmpty(a.c7)) {
                this.c7 = a.c7;
            }
            if (!stringIsNullOrEmpty(a.cz)) {
                this.cz = a.cz;
            }
            if (!stringIsNullOrEmpty(a.cw)) {
                this.cw = a.cw;
            }
            if (a.b2 != null) {
                this.b2 = a.b2;
            }
            if (a.fx != null) {
                this.fx = a.fx;
            }
            if (a.f0 != null) {
                this.f0 = a.f0;
            }
            if (a.f3 != null) {
                this.f3 = a.f3;
            }
            if (a.w != null) {
                this.w = a.w;
            }
            if (a.fy != null) {
                this.fy = a.fy;
            }
            if (a.f1 != null) {
                this.f1 = a.f1;
            }
            if (a.c != null) {
                this.c = a.c;
            }
            if (a.f2 != null) {
                this.f2 = a.f2;
            }
            if (a.d != null) {
                this.d = a.d;
            }
            if (!isNaN_(a.bq)) {
                this.bq = a.bq;
            }
            if (!isNaN_(a.bw)) {
                this.bw = a.bw;
            }
            if (!isNaN_(a.by)) {
                this.by = a.by;
            }
            if (!isNaN_(a.bx)) {
                this.bx = a.bx;
            }
            if (!isNaN_(a.bv)) {
                this.bv = a.bv;
            }
            if (!isNaN_(a.b0)) {
                this.b0 = a.b0;
            }
            if (this.f5 != a.f5) {
                this.f5 = a.f5;
            }
            if (a.actions != null && a.actions.count > 0) {
                this.actions.clear();
                for (let b = 0; b < a.actions.count; b++) {
                    this.actions.add(a.actions._inner[b]);
                }
            }
        }
    }
    ToolAction.$t = /*@__PURE__*/ markType(ToolAction, 'ToolAction', Base.$, [INotifyPropertyChanged_$type]);
    return ToolAction;
})();
/**
 * @hidden
 */
export let ToolActionSubPanel = /*@__PURE__*/ (() => {
    class ToolActionSubPanel extends ToolAction {
        constructor() {
            super();
            this.f6 = null;
            this.f7 = false;
        }
        get_q() {
            return 10;
        }
        ee(a, b) {
            super.ee(a, b);
            if (this.f6 == null || a == null) {
                return;
            }
            let c = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
            let d = this.f6.bb(c);
            b.e = d.width;
            b.d = d.height;
            if (!this.f7) {
                this.f7 = true;
                this.eq();
            }
        }
        eh(a, b, c, d) {
            if (d != null) {
                d();
            }
        }
        ez(a, b, c) {
            let d = b.b;
            if (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q) {
                d.am = enumGetBox(ToolActionType_$type, this.q);
                NativeUIComponent.aq(this.n.p.v(), 13, this.au() ? 2 : 0, (e) => this.f9(d, a, e, c));
            }
            else {
                let e = a.bh(0);
                this.f9(d, a, e, c);
            }
        }
        f9(a, b, c, d) {
            if (b.bi == 0) {
                b.bj(c);
                c.bq = 1;
                c.f = 0;
            }
            c.bp = this.actions;
            c.bo = runOn(this, this.f8);
            if (this.f6 != c) {
                if (this.f6 != null) {
                    this.f6.bo = null;
                }
                this.f6 = c;
            }
        }
        f8(a, b) {
            this.e4(b.a);
        }
        d9(a) {
            super.d9(a);
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                if (this.f6 != null) {
                    this.f6.bo = null;
                }
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
            }
        }
        ej(a) {
            super.ej(a);
        }
    }
    ToolActionSubPanel.$t = /*@__PURE__*/ markType(ToolActionSubPanel, 'ToolActionSubPanel', ToolAction.$);
    return ToolActionSubPanel;
})();
/**
 * @hidden
 */
export let ToolActionButton = /*@__PURE__*/ (() => {
    class ToolActionButton extends ToolAction {
        constructor() {
            super(...arguments);
            this.f6 = 0;
            this.gb = NaN;
            this.f8 = null;
            this.ga = false;
        }
        get_q() {
            return 9;
        }
        get_bz() {
            return 0;
        }
        get f7() {
            return this.f6;
        }
        set f7(a) {
            let b = this.f6;
            this.f6 = a;
            if (this.f6 != b) {
                this.ev("DisplayType", enumGetBox(ToolActionButtonDisplayType_$type, b), enumGetBox(ToolActionButtonDisplayType_$type, this.f6));
            }
        }
        get gc() {
            return this.gb;
        }
        set gc(a) {
            let b = this.gb;
            this.gb = a;
            if (this.gb != b) {
                this.ev("CornerRadius", b, this.gb);
            }
        }
        f9() {
            switch (this.f7) {
                case 0: return 0;
                case 1: return 1;
                case 2: return 2;
                default: return 0;
            }
        }
        k(a) {
            let b = new ToolActionEventDetail();
            b.g = this.dk;
            b.a = this.q;
            b.c = a;
            return b;
        }
        bl(a, b) {
            return NaN;
        }
        bn(a, b) {
            return NaN;
        }
        bm(a, b) {
            let c = super.bn(a, b);
            if (!isNaN_(c)) {
                return c + DeviceUtils.g(32);
            }
            return DeviceUtils.g(88);
        }
        eh(a, b, c, d) {
            if (d != null) {
                d();
            }
        }
        gg(a, b, c, d, e) {
            if (e) {
                if (a.bi == 0) {
                    a.bw(0, 2, 1);
                    a.bj(b);
                    a.b4(b, 0);
                    a.b3(b, 0);
                }
                b.bl = 3;
                b.h = 1;
                b.bq = true;
            }
            a.be = new Thickness(1, this.bh, this.bj, this.bi, this.bg);
            b.c = this.p;
            b.bu = new CornerRadius(0, this.gc);
            b.bj = this.f9();
            b.bt = this.d4;
            b.bi = runOn(this, this.gf);
            b.bg = this.u;
            if (this.f8 != b) {
                if (this.f8 != null) {
                    this.f8.bi = null;
                }
                this.f8 = b;
            }
        }
        gf(a, b) {
            this.ew(this.k(true), this);
        }
        ez(a, b, c) {
            if (this.ga) {
                return;
            }
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q || a.bi == 0) {
                let e = [1];
                let f = [this.y(1)];
                this.ga = true;
                NativeUIComponent.as(this.n.p.v(), e, f, (g) => {
                    this.gg(a, g[0], b, c, true);
                    this.ga = false;
                });
                d.am = enumGetBox(ToolActionType_$type, this.q);
            }
            else {
                let g = a.bh(0);
                this.gg(a, g, b, c, false);
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
                case "Title":
                    if (this.f8 != null) {
                        this.f8.bt = this.d4;
                    }
                    break;
                case "DisplayType":
                    if (this.f8 != null) {
                        this.f8.bj = this.f9();
                    }
                    break;
                case "CornerRadius":
                    if (this.f8 != null) {
                        this.f8.bu = new CornerRadius(0, this.gc);
                    }
                    break;
            }
        }
        fa() {
            super.fa();
            if (this.f8 != null) {
                this.f8.c = this.p;
            }
            if (this.n.o == 1) {
                this.bh = !isNaN_(this.bw) ? this.bw : DeviceUtils.g(4);
                this.bi = !isNaN_(this.bx) ? this.bx : DeviceUtils.g(4);
                this.bj = !isNaN_(this.by) ? this.by : DeviceUtils.g(4);
                this.bg = !isNaN_(this.bv) ? this.bv : DeviceUtils.g(4);
            }
            else {
                this.bh = !isNaN_(this.bw) ? this.bw : DeviceUtils.g(10);
                this.bi = !isNaN_(this.bx) ? this.bx : DeviceUtils.g(10);
                this.bj = !isNaN_(this.by) ? this.by : DeviceUtils.g(4);
                this.bg = !isNaN_(this.bv) ? this.bv : DeviceUtils.g(4);
            }
        }
    }
    ToolActionButton.$t = /*@__PURE__*/ markType(ToolActionButton, 'ToolActionButton', ToolAction.$);
    return ToolActionButton;
})();
/**
 * @hidden
 */
export let ToolActionLabel = /*@__PURE__*/ (() => {
    class ToolActionLabel extends ToolAction {
        get_aj() {
            return this.at() || this.actions.count > 0;
        }
        constructor() {
            super();
            this.f6 = null;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "ToolbarDrillDownIcon") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "ToolbarDrillDownIcon", ToolActionLabel.f7);
            }
        }
        get_q() {
            return 4;
        }
        bm(a, b) {
            return this.actions.count > 0 ? DeviceUtils.g(32) : super.bm(a, b);
        }
        f8(a, b, c, d) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                if (b.bi == 2) {
                    let e = this.bm(this.n, d);
                    b.bw(3, 1, isNaN_(e) ? 0 : e);
                    b.bj(c);
                    b.b3(c, 3);
                    b.b4(c, 0);
                    c.bn = "ToolbarDrillDownIcon";
                    c.bm = "IG_Default";
                    c.f = 1;
                    c.h = 1;
                }
            }
            c.a7 = this.fw;
        }
        et() {
            if (this.actions.count > 0) {
                this.n.eh(this);
            }
            else {
                this.ew(this.k(false), this);
            }
        }
        ez(a, b, c) {
            let d = b.b;
            if (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q) {
                if (this.actions.count > 0) {
                    NativeUIComponent.aq(this.n.p.v(), 11, this.au() ? 2 : 0, (e) => {
                        this.f6 = e;
                        this.f8(d, a, this.f6, c);
                    });
                }
                d.am = enumGetBox(ToolActionType_$type, this.q);
            }
            else {
                if (this.actions.count > 0) {
                    this.f6 = a.bh(2);
                    this.f8(d, a, this.f6, c);
                }
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
                case "ActualTextColor":
                    if (this.f6 != null) {
                        this.f6.a6 = this.fw;
                    }
                    break;
            }
        }
    }
    ToolActionLabel.$t = /*@__PURE__*/ markType(ToolActionLabel, 'ToolActionLabel', ToolAction.$);
    ToolActionLabel.f7 = "M 7.42 8.58 L 12 13.17 L 7.42 17.76 L 8.83 19.17 l 6 -6 l -6 -6 z";
    return ToolActionLabel;
})();
/**
 * @hidden
 */
export let ToolActionRadio = /*@__PURE__*/ (() => {
    class ToolActionRadio extends ToolAction {
        constructor() {
            super(...arguments);
            this.f6 = null;
            this.gb = null;
            this.f7 = false;
            this.f8 = false;
        }
        get_q() {
            return 6;
        }
        get gc() {
            return this.gb;
        }
        set gc(a) {
            this.gb = a;
        }
        get f9() {
            return this.f7;
        }
        set f9(a) {
            let b = this.f7;
            this.f7 = a;
            if (b != this.f7) {
                this.ev("IsChecked", b, this.f7);
            }
        }
        get ga() {
            return this.f8;
        }
        set ga(a) {
            let b = this.f8;
            this.f8 = a;
            if (b != this.f8) {
                this.ev("IsManual", b, this.f8);
            }
        }
        k(a) {
            let b = new ToolActionEventDetail();
            b.g = this.dk;
            b.a = this.q;
            b.c = a;
            if (this.f6 != null) {
                b.b = this.f6.bj;
            }
            return b;
        }
        el(a) {
            super.el(a);
            if (this.f6 != null) {
                a.add(((() => {
                    let $ret = new ToolCommandArgument();
                    $ret.argumentName = "IsChecked";
                    $ret.value = this.f6.bj;
                    return $ret;
                })()));
            }
        }
        gf() {
            if (this.f6 != null) {
                this.f6.bj = false;
                this.f7 = this.f6.bj;
            }
        }
        bm(a, b) {
            return 30;
        }
        fa() {
            if (this.f6 != null) {
                this.f6.c = this.p;
            }
        }
        et() {
            if (!this.ga) {
                this.f6.bj = true;
                this.f7 = this.f6.bj;
            }
            this.ew(this.k(true), this);
        }
        gg(a, b) {
            if (this.f7) {
                this.f6.bj = true;
                return;
            }
            if (this.ga) {
                this.f6.bj = this.f7;
            }
            else {
                this.f7 = this.f6.bj;
            }
            this.ew(this.k(true), this);
        }
        gh(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                b.bw(3, 1, this.bm(this.n, e));
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                c.bi = true;
                c.f = 1;
                c.h = 1;
                c.bk = DeviceUtils.g(10);
                c.ad = DeviceUtils.g(20);
                c.x = DeviceUtils.g(20);
                a.am = enumGetBox(ToolActionType_$type, this.q);
            }
            c.c = this.p;
            c.bj = this.f7;
            c.bh = runOn(this, this.gg);
            if (this.f6 != c) {
                if (this.f6 != null) {
                    this.f6.bh = null;
                }
                this.f6 = c;
            }
        }
        ez(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q) {
                NativeUIComponent.aq(this.n.p.v(), 6, this.y(6), (e) => {
                    let f = e;
                    this.gh(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.q);
            }
            else {
                let e = a.bh(2);
                this.gh(d, a, e, b, c);
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
                case "IsChecked":
                    if (this.f6 != null) {
                        this.f6.bj = this.f9;
                    }
                    break;
            }
        }
        ej(a) {
            super.ej(a);
            let b = a;
            this.f9 = b.isChecked;
            this.gc = b.channel;
        }
    }
    ToolActionRadio.$t = /*@__PURE__*/ markType(ToolActionRadio, 'ToolActionRadio', ToolAction.$);
    return ToolActionRadio;
})();
/**
 * @hidden
 */
export let ToolActionSeparator = /*@__PURE__*/ (() => {
    class ToolActionSeparator extends ToolAction {
        get f9() {
            return this.f8;
        }
        set f9(a) {
            let b = this.f8;
            this.f8 = a;
            if (b != this.f8) {
                this.ev("Size", b, this.f8);
            }
        }
        get f7() {
            return this.f6;
        }
        set f7(a) {
            let b = this.f6;
            this.f6 = a;
            if (b != this.f6) {
                this.ev("IsGroupHeaderSeparator", b, this.f6);
            }
        }
        constructor() {
            super();
            this.f8 = DeviceUtils.g(2);
            this.f6 = false;
        }
        get_q() {
            return 7;
        }
        ee(a, b) {
            super.ee(a, b);
            if (b.a == 1) {
                b.e = this.bh + this.f9 + this.bi;
            }
            else {
                b.d = this.bj + this.f9 + this.bg;
            }
        }
        eh(a, b, c, d) {
            if (d != null) {
                d();
            }
        }
        eg(a, b) {
            if (b.a == 1) {
                a.f = 0;
                a.h = 3;
            }
            else {
                a.f = 3;
            }
        }
        e8(a, b, c) {
            if (c.a == 1) {
                a.ad = this.f9;
            }
            else {
                a.x = this.f9;
            }
            a.bd = new Thickness(1, this.bh, this.bj, this.bi, this.bg);
            a.a4 = this.fq;
            a.bf = this.f5;
        }
        fa() {
            super.fa();
            this.fq = this.fx != null ? this.fx : !this.f7 ? this.n.fo : this.n.fi;
            if (this.n.o == 1) {
                this.bh = !isNaN_(this.bw) ? this.bw : this.n.bc;
                this.bi = !isNaN_(this.bx) ? this.bx : this.n.bd;
                this.bj = !isNaN_(this.by) ? this.by : this.n.be;
                this.bg = !isNaN_(this.bv) ? this.bv : this.n.bb;
            }
            else {
                if (this.h == null && this.ap()) {
                    this.bh = !isNaN_(this.bw) ? this.bw : DeviceUtils.g(10);
                    this.bi = !isNaN_(this.bx) ? this.bx : DeviceUtils.g(10);
                }
                else {
                    this.bh = !isNaN_(this.bw) ? this.bw : this.n.bg;
                    this.bi = !isNaN_(this.bx) ? this.bx : this.n.bh;
                }
                this.bj = !isNaN_(this.by) ? this.by : this.n.bi;
                this.bg = !isNaN_(this.bv) ? this.bv : this.n.bf;
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
                case "Size":
                    if (this.n != null) {
                        this.n.eg();
                    }
                    break;
                case "IsGroupHeaderSeparator":
                    this.e9();
                    break;
            }
        }
        ej(a) {
            super.ej(a);
            let b = a;
            this.f9 = b.size;
            this.f7 = b.isGroupHeaderSeparator;
        }
    }
    ToolActionSeparator.$t = /*@__PURE__*/ markType(ToolActionSeparator, 'ToolActionSeparator', ToolAction.$);
    return ToolActionSeparator;
})();
/**
 * @hidden
 */
export let ToolActionIconButton = /*@__PURE__*/ (() => {
    class ToolActionIconButton extends ToolAction {
        get_q() {
            return 3;
        }
        get_as() {
            return false;
        }
        get gb() {
            return this.ga;
        }
        get_gk() {
            return this.f7 != null;
        }
        get gk() {
            return this.get_gk();
        }
        get gj() {
            return this.gf;
        }
        set gj(a) {
            this.gf = a;
        }
        get go() {
            return this.gn;
        }
        set go(a) {
            this.gn = a;
        }
        constructor() {
            super();
            this.ga = null;
            this.f7 = null;
            this.f6 = null;
            this.gl = -1;
            this.gm = -1;
            this.gg = false;
            this.gd = false;
            this.gc = false;
            this.gf = false;
            this.gn = 500;
            this.gh = false;
            this.f8 = null;
            this.f9 = null;
            this.gi = false;
            this.ge = false;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "igDropDownArrow") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "igDropDownArrow", "M0,0L3,3L6,0");
            }
            this.f6 = new DelayManager(0);
        }
        d8() {
            super.d8();
            NativeUIWindow.h(14, runOn(this, this.g4));
            this.gc = false;
        }
        k(a) {
            let b = new ToolActionEventDetail();
            b.g = this.dk;
            b.a = this.q;
            b.c = a;
            return b;
        }
        bl(a, b) {
            return DeviceUtils.g(36);
        }
        bn(a, b) {
            return NaN;
        }
        eh(a, b, c, d) {
            if (d != null) {
                d();
            }
        }
        d9(a) {
            super.d9(a);
        }
        g6(a, b, c, d, e) {
            let f = c.bk;
            if (e) {
                b.b1(2);
                b.b1(1);
                if (b.bi == 0) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 0);
                c.bl = 2;
                c.bj = 4;
                c.bq = true;
                c.f = 1;
                f.ad = DeviceUtils.g(28);
                f.x = DeviceUtils.g(28);
            }
            b.br = false;
            b.be = new Thickness(1, this.bh, this.bj, this.bi, this.bg);
            f.bn = this.db;
            f.bm = this.c7;
            f.bj = this.bs;
            f.bk = this.bt;
            f.bl = this.bu;
            f.bi = this.br;
            f.a7 = this.fu;
            f.bg = this.c;
            f.a8 = this.fv;
            f.bh = this.d;
            f.ab = this.bq;
            c.c = this.p;
            c.bi = runOn(this, this.gv);
            c.q = runOn(this, this.gx);
            c.s = runOn(this, this.gy);
            c.o = runOn(this, this.gw);
            if (this.f8 != c) {
                if (this.f8 != null) {
                    this.f8.bi = null;
                    this.f8.q = null;
                    this.f8.s = null;
                    this.f8.o = null;
                }
                this.f8 = c;
            }
            if (this.f9 != f) {
                this.f9 = f;
            }
        }
        g7(a, b) {
            if (this.ga != b) {
                if (this.ga != null) {
                    this.ga.q = null;
                    this.ga.s = null;
                    this.ga.n = null;
                    this.ga.o = null;
                }
                this.ga = b;
                this.ga.b1 = this.n.bj;
                this.ga.b9 = BrushUtil.h(255, 255, 255, 255);
                this.ga.bo = 1;
                this.ga.bx = true;
                this.ga.b3 = 100;
                this.ga.bv = true;
                this.ga.b4 = truncate(this.n.bk);
                this.ga.by = true;
                if (a.bi != 2) {
                    a.bj(this.ga);
                }
                this.gq();
                this.ga.q = runOn(this, this.g2);
                this.ga.s = runOn(this, this.g3);
                this.ga.n = runOn(this, this.g0);
                this.ga.o = runOn(this, this.g1);
                if (!this.gc) {
                    NativeUIWindow.g(14, runOn(this, this.g4));
                    this.gc = true;
                }
            }
            if (this.actions.count > 0) {
                this.ga.u = true;
            }
            else {
                this.ga.u = false;
            }
        }
        gq() {
            if (this.ga.bi == 0) {
                this.f7 = new TooltipTextPresenter(this.n.p.v());
                this.f7.t(() => this.ga.bj(this.f7.e));
            }
            else {
                this.f7 = this.ga.bh(0).am;
            }
            this.f7.b = this.n.u;
            this.f7.y = this.n.fr;
            this.f7.z = this.n.fs;
            this.f7.p = this.d4;
            this.ga.ca = this.f7.y;
        }
        gs() {
        }
        gr() {
        }
        gt() {
            if (this.f7 != null) {
                this.ga.ca = this.n.fr;
                this.f7.y = this.n.fr;
                this.f7.z = this.n.fs;
                this.ga.b1 = this.n.bj;
                this.ga.b4 = truncate(this.n.bk);
            }
        }
        g8() {
            if (this.f7 != null) {
                return this.f7.aa();
            }
            return Size.empty;
        }
        g4() {
            if (this.f8 != null) {
                let a = this.f8.ba();
                this.ga.b7(a);
            }
        }
        ez(a, b, c) {
            if (this.gi) {
                return;
            }
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q || a.bi == 0) {
                this.gi = true;
                NativeUIComponent.as(this.n.p.v(), [10, 12], [this.y(10), this.y(12)], (e) => {
                    this.g6(d, a, e[0], c, true);
                    this.g7(a, e[1]);
                    this.gi = false;
                });
                d.am = enumGetBox(ToolActionType_$type, this.q);
            }
            else {
                let e = a.bh(0);
                let f = a.bh(1);
                this.g6(d, a, e, c, false);
                this.g7(a, f);
            }
        }
        fa() {
            super.fa();
            this.bh = !isNaN_(this.bw) ? this.bw : DeviceUtils.g(4);
            this.bi = !isNaN_(this.bx) ? this.bx : DeviceUtils.g(4);
            if (this.f8 != null) {
                this.f8.c = this.p;
                if (typeCast(NativeUIIconButton.$, this.f8) !== null) {
                    this.f8.a7 = this.fw;
                    this.f8.a8 = this.fw;
                }
            }
            if (this.f9 != null) {
                this.f9.a7 = this.fu;
                this.f9.a8 = this.fv;
                this.f9.bg = this.c;
                this.f9.bh = this.d;
            }
            this.gt();
        }
        eu() {
            if (this.f9 != null) {
                this.f9.bn = this.db;
                this.f9.bm = this.c7;
            }
        }
        e0() {
            if (this.actions.count > 0) {
                if (this.ga == null || !this.gk) {
                    this.gf = true;
                }
                else {
                    this.g5();
                    this.gg = true;
                }
            }
        }
        ea() {
            if (this.actions.count > 0) {
                if (this.ga == null || !this.gk) {
                    this.gf = false;
                }
                else {
                    this.gp();
                }
            }
        }
        g5(a = false) {
            if (!this.gh) {
                this.n.dw();
                if (this.actions.count == 0 && stringIsNullOrEmpty(this.d4)) {
                    return;
                }
                let b = this.f8.ba();
                let c = new Rect(0, b.left, b.top, b.width, b.height);
                c.top = b.top + (window.scrollY);
                c.left = b.left + (window.scrollX);
                if (this.n.o == 1) {
                    let d = NativeUIWindow.d(this.n.p.n);
                    let e = this.g8();
                    e.height += this.ga.b2;
                    if (b.bottom + e.height > d) {
                        if (b.top - e.height < 0) {
                            this.ga.b8(c, 1, 3);
                        }
                        else {
                            this.ga.b8(c, 2, 3);
                        }
                    }
                    else {
                        this.ga.b8(c, 1, 3);
                    }
                }
                else {
                    let f = NativeUIWindow.f(this.n.p.n);
                    let g = this.g8();
                    g.width += this.ga.b2;
                    if (b.right + g.width > f) {
                        if (b.left - g.width < 0) {
                            this.ga.b8(c, 4, 3);
                        }
                        else {
                            this.ga.b8(c, 3, 3);
                        }
                    }
                    else {
                        this.ga.b8(c, 4, 3);
                    }
                }
                this.gh = true;
                this.gs();
            }
            this.gg = a;
            this.gf = false;
        }
        gp() {
            if (this.gh) {
                this.ga.b5();
                this.gh = false;
                this.f6.f(() => this.gr(), 100);
                this.gg = false;
            }
        }
        gz() {
            this.g5();
            this.gm = -1;
        }
        gu() {
            this.gp();
            this.gl = -1;
        }
        gx(a, b) {
            this.gd = true;
            if (this.gl != -1) {
                this.f6.g(this.gl);
                this.gl = -1;
            }
            if (!this.gh) {
                if (this.actions.count > 0 && !this.n.ae) {
                    return;
                }
                this.gm = this.f6.f(runOn(this, this.gz), this.go);
            }
        }
        gy(a, b) {
            if (this.gm != -1) {
                this.f6.g(this.gm);
                this.gm = -1;
            }
            if (this.gh && !this.gg) {
                this.gl = this.f6.f(runOn(this, this.gu), 50);
            }
            this.gd = false;
        }
        gv(a, b) {
            if (this.actions.count > 0) {
                if (!this.gh) {
                    if (this.gm != -1) {
                        this.f6.g(this.gm);
                        this.gm = -1;
                    }
                    this.g5();
                    this.gg = true;
                }
                else {
                    this.gp();
                }
            }
            else {
                this.ew(this.k(true), this);
            }
        }
        g2(a, b) {
            this.ge = true;
            if (this.gl != -1) {
                this.f6.g(this.gl);
                this.gl = -1;
            }
        }
        g3(a, b) {
            if (!this.gg) {
                this.gl = this.f6.f(runOn(this, this.gu), 50);
            }
            this.ge = false;
        }
        g0(a, b) {
            this.gg = true;
        }
        g1(a, b) {
            if (!this.ga.t(b.a) && !this.f8.t(b.a)) {
                this.gp();
            }
        }
        gw(a, b) {
            if (this.gh) {
                if (!this.ga.t(b.a) && !this.f8.t(b.a)) {
                    this.gp();
                }
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
                case "ExecutionContext":
                    this.f6.b = this.f;
                    break;
                case "Title":
                    if (this.f7 != null) {
                        this.f7.p = this.d4;
                    }
                    break;
                case "ActualIconFill":
                case "ActualIconStroke":
                case "IconFillColors":
                case "IconStrokeColors":
                    if (this.f9 != null) {
                        this.f9.a7 = this.fu;
                        this.f9.a8 = this.fv;
                        this.f9.bg = this.c;
                        this.f9.bh = this.d;
                    }
                    break;
            }
        }
        ej(a) {
            super.ej(a);
            let b = a;
            this.go = b.tooltipDelay;
            if (b.isMenuOpenOnStart) {
                this.e0();
            }
        }
    }
    ToolActionIconButton.$t = /*@__PURE__*/ markType(ToolActionIconButton, 'ToolActionIconButton', ToolAction.$);
    return ToolActionIconButton;
})();
/**
 * @hidden
 */
export let ToolActionGroupHeader = /*@__PURE__*/ (() => {
    class ToolActionGroupHeader extends ToolAction {
        get_q() {
            return 1;
        }
        get_aj() {
            return false;
        }
        get_ak() {
            return false;
        }
        get_aq() {
            return false;
        }
        get gf() {
            return this.gd;
        }
        set gf(a) {
            let b = this.gd;
            this.gd = a;
            if (b != this.gd) {
                this.ev("ActualBackIconColor", b, this.gd);
            }
        }
        get gg() {
            return this.ge;
        }
        set gg(a) {
            let b = this.ge;
            this.ge = a;
            if (b != this.ge) {
                this.ev("BackIconColor", b, this.ge);
            }
        }
        constructor() {
            super();
            this.f6 = ((() => {
                let $ret = new FontInfo();
                $ret.q = "Verdana";
                $ret.f = 13;
                $ret.t = "Normal";
                $ret.v = "Bold";
                $ret.r = "Normal";
                return $ret;
            })());
            this.f7 = null;
            this.gd = null;
            this.ge = null;
            if (SvgIconRegistry.instance.getSvgPathString("IG_Default", "ToolbarBackButton") == null) {
                SvgIconRegistry.instance.addSvgPathString("IG_Default", "ToolbarBackButton", ToolActionGroupHeader.f9);
            }
        }
        v(a) {
            return this.f6;
        }
        bk(a, b) {
            return this.ar() ? DeviceUtils.g(36) : NaN;
        }
        gc(a, b, c, d) {
            let e = c.bk;
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                if (b.bi == 2) {
                    b.bj(c);
                    b.bz(0, 1, this.bk(this.n, d));
                    b.b3(b.bh(0), 1);
                    b.b3(b.bh(1), 2);
                    b.b3(c, 0);
                    b.b4(c, 0);
                    c.h = 1;
                    c.f = 1;
                    c.bd = new Thickness(1, -9, 0, 9, 0);
                    e.bn = "ToolbarBackButton";
                    e.bm = "IG_Default";
                }
            }
            e.a7 = this.gf;
            c.c = this.p;
            c.bi = runOn(this, this.gb);
            if (this.f7 != c) {
                if (this.f7 != null) {
                    this.f7.bi = null;
                }
                this.f7 = c;
            }
        }
        gb(a, b) {
            this.n.ei(this);
        }
        d9(a) {
            super.d9(a);
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                if (this.ar() && this.f7 != null) {
                    this.f7.bi = null;
                }
            }
        }
        ez(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q) {
                if (this.ar()) {
                    NativeUIComponent.aq(this.n.p.v(), 10, this.au() ? 2 : 0, (e) => this.gc(d, a, e, c));
                }
                d.am = enumGetBox(ToolActionType_$type, this.q);
            }
            else {
                if (this.ar()) {
                    let e = a.bh(2);
                    this.gc(d, a, e, c);
                }
            }
        }
        fa() {
            super.fa();
            if (this.f7 != null) {
                this.f7.c = this.p;
            }
            this.fq = this.fx != null ? this.fx : this.n.fh;
            this.fw = this.f3 != null ? this.f3 : this.n.fj;
            this.gf = this.gg != null ? this.gg : this.fw;
            let a;
            if (this.w != null) {
                a = this.w.a();
            }
            else {
                if (this.n.u != null) {
                    a = this.n.u.a();
                    a.v = "Bold";
                }
                else {
                    a = this.f6;
                }
            }
            this.u = a;
        }
    }
    ToolActionGroupHeader.$t = /*@__PURE__*/ markType(ToolActionGroupHeader, 'ToolActionGroupHeader', ToolAction.$);
    ToolActionGroupHeader.f9 = "M20 11H7.83l5.59-5.59L12 4l-8 8 8 8 1.41-1.41L7.83 13H20v-2z";
    return ToolActionGroupHeader;
})();
/**
 * @hidden
 */
export let ToolActionIconMenu = /*@__PURE__*/ (() => {
    class ToolActionIconMenu extends ToolActionIconButton {
        constructor() {
            super(...arguments);
            this.g9 = null;
            this.hb = false;
            this.ha = null;
            this.hm = null;
            this.hn = ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(255, 0, 0, 0);
                return $ret;
            })());
            this.hl = null;
            this.hc = true;
            this.hd = false;
        }
        get_q() {
            return 8;
        }
        get hp() {
            return this.hm;
        }
        set hp(a) {
            let b = this.hm;
            this.hm = a;
            if (b != this.hm) {
                this.ev("ArrowStroke", b, this.hm);
            }
        }
        get ho() {
            return this.hl;
        }
        set ho(a) {
            let b = this.hl;
            this.hl = a;
            if (b != this.hl) {
                this.ev("ActualIconStroke", b, this.hl);
            }
        }
        get he() {
            return this.hc;
        }
        set he(a) {
            let b = this.hc;
            this.hc = a;
            if (b != this.hc) {
                this.ev("ShowArrowIcon", b, this.hc);
            }
        }
        get_gk() {
            return this.g9 != null;
        }
        gq() {
            this.hb = false;
            if (this.gb.bi > 0) {
                while (this.gb.bi > 0) {
                    this.gb.bm(0);
                }
            }
            if (this.g9 != null) {
                this.g9.s = null;
            }
            this.g9 = new ToolPanelsPresenter(this.n.p.v(), this.f);
            this.g9.n = this.p;
            this.g9.ai(() => {
                this.g9.ae(this, (a) => {
                    this.g9.aj(a);
                    if (this.actions.count > 0 && this.actions._inner[0].fq != null && !BrushUtilCore.a(this.actions._inner[0].fq)) {
                        this.gb.ca = this.actions._inner[0].fq;
                    }
                    else {
                        this.gb.ca = this.n.fp;
                    }
                    if (this.gj) {
                        this.f.executeDelayed(() => this.g5(true), 100);
                    }
                });
                this.g9.r.a3 = new CornerRadius(0, 8);
                this.g9.r.a4 = this.n.fp;
                this.gb.bj(this.g9.r);
            });
            this.g9.s = runOn(this, this.hi);
        }
        eq() {
            super.eq();
            this.hb = true;
        }
        gs() {
            if (this.g9 != null) {
                this.g9.am();
            }
        }
        gr() {
            if (this.g9 != null) {
                this.g9.aw();
                this.gb.b6();
            }
        }
        gt() {
            if (this.g9 != null) {
                this.g9.ax(this.p, this.n);
                if (this.actions.count > 0 && this.actions._inner[0].fq != null && !BrushUtilCore.a(this.actions._inner[0].fq)) {
                    this.gb.ca = this.actions._inner[0].fq;
                }
                else {
                    this.gb.ca = this.n.fp;
                }
                this.gb.b1 = 8;
                this.gb.b4 = 4;
            }
        }
        fa() {
            super.fa();
            this.ho = this.hp != null ? this.hp : this.hn;
            if (this.ha != null) {
                this.ha.a8 = this.ho;
            }
        }
        g8() {
            if (this.hb) {
                this.gq();
            }
            return this.g9.a2();
        }
        g5(a = false) {
            if (this.g9 != null) {
                this.g9.aw();
            }
            super.g5(a);
        }
        hk(a, b, c, d, e, f, g) {
            if (g) {
                a.b1(2);
                a.b1(1);
                if (a.bi == 0) {
                    c.bw(0, 1, DeviceUtils.g(28));
                    c.bw(1, 1, DeviceUtils.g(6));
                    c.bj(d);
                    c.bj(e);
                    c.b3(d, 0);
                    c.b3(e, 1);
                    b.bk = c;
                    a.bj(b);
                }
                a.b4(b, 0);
                a.b3(b, 0);
                b.bl = 2;
                b.bj = 4;
                b.bq = true;
                b.f = 1;
                d.ad = DeviceUtils.g(28);
                d.x = DeviceUtils.g(28);
                d.h = 1;
                e.ad = DeviceUtils.g(6);
                e.x = DeviceUtils.g(4);
                e.h = 1;
                e.bd = new Thickness(1, -4, 0, 0, 0);
                e.bn = "igDropDownArrow";
                e.bm = "IG_Default";
                e.bj = 0;
                e.bk = 0;
                e.bl = 6;
                e.bi = 4;
                e.a7 = BrushUtil.h(0, 0, 0, 0);
                e.ab = DeviceUtils.g(1);
            }
            a.br = false;
            a.be = new Thickness(1, this.bh, this.bj, this.bi, this.bg);
            d.bn = this.db;
            d.bm = this.c7;
            d.bj = this.bs;
            d.bk = this.bt;
            d.bl = this.bu;
            d.bi = this.br;
            d.a7 = this.fu;
            d.a8 = this.fv;
            e.a8 = this.ho;
            b.c = this.p;
            b.bi = runOn(this, this.gv);
            b.q = runOn(this, this.gx);
            b.s = runOn(this, this.gy);
            b.o = runOn(this, this.gw);
            if (this.f8 != b) {
                if (this.f8 != null) {
                    this.f8.bi = null;
                    this.f8.q = null;
                    this.f8.s = null;
                    this.f8.o = null;
                }
                this.f8 = b;
            }
            if (this.f9 != d) {
                this.f9 = d;
            }
            if (this.ha != e) {
                this.ha = e;
            }
            this.hj();
        }
        ez(a, b, c) {
            if (this.hd) {
                return;
            }
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q || a.bi == 0) {
                let e = [1, 7, 11, 11, 12];
                let f = [this.y(1), this.y(7), this.y(11), this.y(11), this.y(12)];
                this.hd = true;
                NativeUIComponent.as(this.n.p.v(), e, f, (g) => {
                    this.hk(a, g[0], g[1], g[2], g[3], c, true);
                    this.g7(a, g[4]);
                    this.hd = false;
                });
                d.am = enumGetBox(ToolActionType_$type, this.q);
            }
            else {
                let g = a.bh(0);
                let h = g.bk;
                let i = h.bh(0);
                let j = h.bh(1);
                let k = a.bh(1);
                this.hk(a, g, h, i, j, c, false);
                this.g7(a, k);
            }
        }
        hi(a) {
            this.e4(a.a);
            if (a.b) {
                this.ea();
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
                case "ShowArrowIcon":
                    this.hj();
                    break;
            }
        }
        hj() {
            if (this.f8 == null || this.f9 == null || this.ha == null) {
                return;
            }
            if (this.he) {
                let a = this.f8.bk;
                if (a.bs == 2) {
                    a.b5(0, 1, DeviceUtils.g(28));
                    a.b5(1, 1, DeviceUtils.g(6));
                }
                else {
                    a.bw(0, 1, DeviceUtils.g(28));
                    a.bw(1, 1, DeviceUtils.g(6));
                }
                a.b3(this.f9, 0);
                a.b3(this.ha, 1);
                this.ha.bf = 0;
            }
            else {
                let b = this.f8.bk;
                b.b5(1, 1, DeviceUtils.g(0));
                this.ha.bf = 1;
            }
        }
        d7(a, b) {
            super.d7(a, b);
            switch (b) {
                case "Visibility":
                    if (this.g9 != null) {
                        this.g9.av();
                    }
                    break;
            }
        }
        e1(a) {
            super.e1(a);
            if (a.q == 8) {
                let b = a;
                if (this.he != b.he) {
                    this.he = b.he;
                }
                if (this.hp != b.hp) {
                    this.hp = b.hp;
                }
            }
        }
    }
    ToolActionIconMenu.$t = /*@__PURE__*/ markType(ToolActionIconMenu, 'ToolActionIconMenu', ToolActionIconButton.$);
    return ToolActionIconMenu;
})();
/**
 * @hidden
 */
export let ToolActionCheckbox = /*@__PURE__*/ (() => {
    class ToolActionCheckbox extends ToolAction {
        constructor() {
            super(...arguments);
            this.f6 = null;
            this.f7 = false;
        }
        get_q() {
            return 2;
        }
        get_ah() {
            return false;
        }
        get f8() {
            return this.f7;
        }
        set f8(a) {
            let b = this.f7;
            this.f7 = a;
            if (b != this.f7) {
                this.ev("IsChecked", b, this.f7);
            }
        }
        k(a) {
            let b = new ToolActionEventDetail();
            b.g = this.dk;
            b.a = this.q;
            b.c = a;
            if (this.f6 != null) {
                b.b = this.f6.bj;
            }
            return b;
        }
        el(a) {
            super.el(a);
            if (this.f6 != null) {
                a.add(((() => {
                    let $ret = new ToolCommandArgument();
                    $ret.argumentName = "IsChecked";
                    $ret.value = this.f6.bj;
                    return $ret;
                })()));
            }
        }
        bm(a, b) {
            return DeviceUtils.g(32);
        }
        d9(a) {
            super.d9(a);
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                if (this.f6 != null) {
                    this.f6.bh = null;
                }
            }
        }
        et() {
            this.f6.bj = !this.f6.bj;
            this.f7 = this.f6.bj;
            this.ew(this.k(true), this);
        }
        gb(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                b.bw(3, 1, this.bm(this.n, e));
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                c.bi = true;
                c.f = 1;
                c.h = 1;
                c.ad = DeviceUtils.g(20);
                c.x = DeviceUtils.g(20);
            }
            c.c = this.p;
            c.bj = this.f7;
            c.bh = runOn(this, this.ga);
            if (this.f6 != c) {
                if (this.f6 != null) {
                    this.f6.bh = null;
                }
                this.f6 = c;
            }
        }
        ga(a, b) {
            this.f7 = this.f6.bj;
            this.ew(this.k(true), this);
        }
        ez(a, b, c) {
            let d = b.b;
            if (d.bo == null || d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q) {
                NativeUIComponent.aq(this.n.p.v(), 6, this.y(6), (e) => {
                    let f = e;
                    this.gb(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.q);
            }
            else {
                let e = a.bh(2);
                this.gb(d, a, e, b, c);
            }
        }
        fa() {
            if (this.f6 != null) {
                this.f6.c = this.p;
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
                case "IsChecked":
                    if (this.f6 != null) {
                        this.f6.bj = this.f7;
                    }
                    break;
            }
        }
        ej(a) {
            super.ej(a);
            let b = a;
            this.f8 = b.isChecked;
        }
    }
    ToolActionCheckbox.$t = /*@__PURE__*/ markType(ToolActionCheckbox, 'ToolActionCheckbox', ToolAction.$);
    return ToolActionCheckbox;
})();
/**
 * @hidden
 */
export let ToolActionNumberInput = /*@__PURE__*/ (() => {
    class ToolActionNumberInput extends ToolAction {
        constructor() {
            super(...arguments);
            this.f6 = null;
            this.f7 = 0;
        }
        get_q() {
            return 5;
        }
        get f9() {
            return this.f7;
        }
        set f9(a) {
            let b = this.f7;
            this.f7 = a;
            if (b != this.f7) {
                this.ev("Value", b, this.f7);
            }
        }
        el(a) {
            super.el(a);
            if (this.f6 != null) {
                a.add(((() => {
                    let $ret = new ToolCommandArgument();
                    $ret.argumentName = "Value";
                    $ret.value = this.f8();
                    return $ret;
                })()));
            }
        }
        bm(a, b) {
            return DeviceUtils.g(70);
        }
        f8() {
            let a;
            a = NaN;
            if (this.f6 != null && ((() => { let b = tryParseNumber(this.f6.bq, a); a = b.p1; return b.ret; })())) {
            }
            return a;
        }
        k(a) {
            let b = new ToolActionEventDetail();
            b.g = this.dk;
            b.a = this.q;
            b.c = a;
            let c;
            b.e = this.f8();
            return b;
        }
        gb(a, b) {
            this.f9 = this.f8();
            let c = this.k(true);
            this.ew(c, this);
        }
        gc(a, b, c, d, e) {
            if (a.am == null || EnumUtil.getEnumValue(ToolActionType_$type, a.am) != this.q) {
                let f = this.bm(this.n, e);
                b.bw(3, 1, f);
                if (b.bi == 2) {
                    b.bj(c);
                }
                b.b4(c, 0);
                b.b3(c, 3);
                c.ad = f;
                c.bj = 2;
                c.bm = 1;
                c.f = 2;
                c.h = 1;
                c.bn = 1;
                c.bi = 2;
                c.bp = false;
            }
            c.c = this.p;
            c.bt = this.an ? this.fr : this.fw;
            c.bg = this.u;
            c.bo = this.an;
            c.bl = runOn(this, this.gb);
            if (!isNaN_(this.f9)) {
                c.bq = this.f9.toString();
            }
            if (this.f6 != c) {
                if (this.f6 != null) {
                    this.f6.bl = null;
                }
                this.f6 = c;
            }
        }
        ez(a, b, c) {
            let d = b.b;
            if (d.bo == null || (d.am == null || EnumUtil.getEnumValue(ToolActionType_$type, d.am) != this.q)) {
                NativeUIComponent.aq(this.n.p.v(), 2, this.y(2), (e) => {
                    let f = e;
                    this.gc(d, a, f, b, c);
                });
                d.am = enumGetBox(ToolActionType_$type, this.q);
            }
            else {
                let e = a.bh(2);
                this.gc(d, a, e, b, c);
            }
        }
        fa() {
            if (this.f6 != null) {
                this.f6.c = this.p;
            }
        }
        e2(a, b, c) {
            super.e2(a, b, c);
            switch (a) {
                case "IsDisabled":
                    if (this.f6 != null) {
                        this.f6.bo = this.an;
                        this.f6.bt = this.an ? this.fr : this.fw;
                    }
                    break;
            }
        }
        et() {
            if (this.f6 != null && !this.an) {
                this.f6.aw();
            }
        }
        ej(a) {
            super.ej(a);
            let b = a;
            this.f9 = b.value;
        }
    }
    ToolActionNumberInput.$t = /*@__PURE__*/ markType(ToolActionNumberInput, 'ToolActionNumberInput', ToolAction.$);
    return ToolActionNumberInput;
})();
/**
 * @hidden
 */
export let ToolActionCollection = /*@__PURE__*/ (() => {
    class ToolActionCollection extends ObservableCollection$1 {
        constructor() {
            super(ToolAction.$, 0);
            this.collectionResetting = null;
        }
        p() {
            if (this.collectionResetting != null) {
                this.collectionResetting(this, null);
            }
            super.p();
        }
    }
    ToolActionCollection.$t = /*@__PURE__*/ markType(ToolActionCollection, 'ToolActionCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(ToolAction.$));
    return ToolActionCollection;
})();
/**
 * @hidden
 */
export let Toolbar = /*@__PURE__*/ (() => {
    class Toolbar extends Base {
        constructor() {
            super();
            this.m = null;
            this.y = false;
            this.w = null;
            this.p = null;
            this.n = null;
            this.q = 0;
            this.f = new ToolActionCollection();
            this.d = new ToolActionCollection();
            this.e = new ToolActionCollection();
            this.j = Toolbar.k;
            this.s = null;
            this.a7 = Toolbar.a8;
            this.c1 = null;
            this.da = null;
            this.c3 = null;
            this.c9 = null;
            this.c6 = null;
            this.db = null;
            this.c2 = null;
            this.c4 = null;
            this.dd = null;
            this.dc = null;
            this.ar = NaN;
            this.as = NaN;
            this.c7 = null;
            this.c8 = null;
            this.t = null;
            this.ao = NaN;
            this.ap = NaN;
            this.aq = NaN;
            this.an = NaN;
            this.ak = NaN;
            this.al = NaN;
            this.am = NaN;
            this.aj = NaN;
            this.ab = true;
            this.ai = NaN;
            this.ah = NaN;
            this.c5 = null;
            this.a5 = -1;
            this._userSetWidth = false;
            this._userSetHeight = false;
            this.aa = false;
            this.z = false;
            this.propertyChanged = null;
            this.b = null;
            this.onCommand = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.cc));
            let b = this.actualActions;
            b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.ce));
            let c = this.actualActions;
            c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.cf));
            NativeUIInputsFactory.n();
            NativeUIXInputsFactory.j();
            let d = new ToolbarView();
            d.a = this;
            this.m = d;
            this.m.w();
        }
        get x() {
            if (this.w == null) {
                this.w = new SRProvider(this.m.j);
                this.w.cb("Layouts");
            }
            return this.w;
        }
        ck(a) {
            this.p = a;
            this.p.by = this;
            this.p.r = this.q == 0 ? 1 : this.q;
            let b = this.p;
            b.onCommand = delegateCombine(b.onCommand, runOn(this, this.cb));
            this.p.o = this.l;
            this.p.ae = this.ae;
            this.p.f4 = this.dp;
            this.p.fu = this.df;
            this.p.ft = this.de;
            this.p.f3 = this.dn;
            this.p.fv = this.dg;
            this.p.fx = this.dh;
            this.p.f2 = this.dm;
            this.p.fz = this.dj;
            this.p.f6 = this.dr;
            this.p.f5 = this.dq;
            this.p.bv = this.a3;
            this.p.bw = this.a4;
            this.p.f0 = this.dk;
            this.p.f1 = this.dl;
            this.p.v = this.u;
            this.p.bo = this.aw;
            this.p.bp = this.ax;
            this.p.bq = this.ay;
            this.p.bn = this.av;
            this.p.bs = this.a0;
            this.p.bt = this.a1;
            this.p.bu = this.a2;
            this.p.br = this.az;
            this.p.fy = this.di;
            this.p.bl = this.at;
            this.p.bm = this.au;
            if (this.a5 != -1) {
                this.p.bx = this.a5;
            }
        }
        cb(a, b) {
            let c = false;
            if (this.s != null) {
                if (this.s.onToolCommandExecuting(b.a) == 2) {
                    c = true;
                    this.n = b;
                }
            }
            if (this.onCommand != null && !c) {
                this.onCommand(this, b);
            }
        }
        cr(a) {
            if (this.onCommand != null) {
                this.onCommand(this, this.n);
                this.n = null;
            }
        }
        cp() {
            let a = this.target;
            this.cq(a, a);
        }
        cn(a) {
            this.p.notifySizeChanged();
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.co("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get autoGeneratedActions() {
            return this.f;
        }
        set autoGeneratedActions(a) {
            let b = this.f;
            this.f = a;
            if (b != this.f) {
                this.co("AutoGeneratedActions", b, this.f);
            }
        }
        get actions() {
            return this.d;
        }
        set actions(a) {
            let b = this.d;
            this.d = a;
            if (b != this.d) {
                this.co("Actions", b, this.d);
            }
        }
        get actualActions() {
            return this.e;
        }
        set actualActions(a) {
            let b = this.e;
            this.e = a;
            if (b != this.e) {
                this.co("ActualActions", b, this.e);
            }
        }
        get l() {
            return this.j;
        }
        set l(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.co("Orientation", enumGetBox(ToolbarOrientation_$type, b), enumGetBox(ToolbarOrientation_$type, a));
            }
        }
        get target() {
            return this.a7;
        }
        set target(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.co("Target", b, a);
            }
        }
        get de() {
            return this.c1;
        }
        set de(a) {
            let b = this.c1;
            this.c1 = a;
            if (b != this.c1) {
                this.co("BackgroundColor", b, a);
            }
        }
        get dn() {
            return this.da;
        }
        set dn(a) {
            let b = this.da;
            this.da = a;
            if (b != this.da) {
                this.co("SubmenuBackgroundColor", b, this.da);
            }
        }
        get dg() {
            return this.c3;
        }
        set dg(a) {
            let b = this.c3;
            this.c3 = a;
            if (b != this.c3) {
                this.co("GroupHeaderBackgroundColorPropertyName", b, this.c3);
            }
        }
        get dm() {
            return this.c9;
        }
        set dm(a) {
            let b = this.c9;
            this.c9 = a;
            if (b != this.c9) {
                this.co("SeparatorBackgroundColor", b, this.c9);
            }
        }
        get dj() {
            return this.c6;
        }
        set dj(a) {
            let b = this.c6;
            this.c6 = a;
            if (b != this.c6) {
                this.co("HoverBackgroundColor", b, this.c6);
            }
        }
        get dp() {
            return this.db;
        }
        set dp(a) {
            let b = this.db;
            this.db = a;
            if (b != this.db) {
                this.co("TextColor", b, this.db);
            }
        }
        get df() {
            return this.c2;
        }
        set df(a) {
            let b = this.c2;
            this.c2 = a;
            if (b != this.c2) {
                this.co("DisabledTextColor", b, this.c2);
            }
        }
        get dh() {
            return this.c4;
        }
        set dh(a) {
            let b = this.c4;
            this.c4 = a;
            if (b != this.c4) {
                this.co("GroupHeaderTextColor", b, this.c4);
            }
        }
        get dr() {
            return this.dd;
        }
        set dr(a) {
            let b = this.dd;
            this.dd = a;
            if (b != this.dd) {
                this.co("ToolTipTextColor", b, this.dd);
            }
        }
        get dq() {
            return this.dc;
        }
        set dq(a) {
            let b = this.dc;
            this.dc = a;
            if (b != this.dc) {
                this.co("ToolTipBackgroundColor", b, this.dc);
            }
        }
        get a3() {
            return this.ar;
        }
        set a3(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.co("ToolTipCornerRadius", b, this.ar);
            }
        }
        get a4() {
            return this.as;
        }
        set a4(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.co("ToolTipElevation", b, this.as);
            }
        }
        get dk() {
            return this.c7;
        }
        set dk(a) {
            let b = this.c7;
            this.c7 = a;
            if (b != this.c7) {
                this.co("IconFill", b, this.c7);
            }
        }
        get dl() {
            return this.c8;
        }
        set dl(a) {
            let b = this.c8;
            this.c8 = a;
            if (b != this.c8) {
                this.co("IconStroke", b, this.c8);
            }
        }
        get u() {
            return this.t;
        }
        set u(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.co("CellTextStyle", b, this.t);
            }
        }
        v() {
            if (this.u == null) {
                return this.m.d();
            }
            return this.u;
        }
        get a0() {
            return this.ao;
        }
        set a0(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.co("SeparatorVerticalPaddingLeft", b, this.ao);
            }
        }
        get a1() {
            return this.ap;
        }
        set a1(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.co("SeparatorVerticalPaddingRight", b, this.ap);
            }
        }
        get a2() {
            return this.aq;
        }
        set a2(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.co("SeparatorVerticalPaddingTop", b, this.aq);
            }
        }
        get az() {
            return this.an;
        }
        set az(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.co("SeparatorVerticalPaddingBottom", b, this.an);
            }
        }
        get aw() {
            return this.ak;
        }
        set aw(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.co("SeparatorHorizontalPaddingLeft", b, this.ak);
            }
        }
        get ax() {
            return this.al;
        }
        set ax(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.co("SeparatorHorizontalPaddingRight", b, this.al);
            }
        }
        get ay() {
            return this.am;
        }
        set ay(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.co("SeparatorHorizontalPaddingTop", b, this.am);
            }
        }
        get av() {
            return this.aj;
        }
        set av(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.co("SeparatorHorizontalPaddingBottom", b, this.aj);
            }
        }
        get ae() {
            return this.ab;
        }
        set ae(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.co("ShowOnHover", b, this.ab);
            }
        }
        get au() {
            return this.ai;
        }
        set au(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.co("HighlightWidth", b, this.ai);
            }
        }
        get at() {
            return this.ah;
        }
        set at(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.co("HighlightRadius", b, this.ah);
            }
        }
        get di() {
            return this.c5;
        }
        set di(a) {
            let b = this.c5;
            this.c5 = a;
            if (b != this.c5) {
                this.co("HighlightColor", b, this.c5);
            }
        }
        get a6() {
            return this.p != null ? this.p.bx : -1;
        }
        set a6(a) {
            this.a5 = a;
            if (this.p != null) {
                this.p.bx = this.a5;
            }
        }
        get userSetWidth() {
            return this._userSetWidth;
        }
        set userSetWidth(a) {
            this._userSetWidth = a;
        }
        get userSetHeight() {
            return this._userSetHeight;
        }
        set userSetHeight(a) {
            this._userSetHeight = a;
        }
        cc(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        let d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.cd));
                    }
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        let f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.cd));
                    }
                }
            }
            this.cm();
        }
        ce(a, b) {
            this.c0();
        }
        cf(a, b) {
            for (let c = 0; c < this.actualActions.count; c++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actualActions._inner[c]) !== null) {
                    let d = this.actualActions._inner[c];
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.cd));
                }
                this.actualActions._inner[c].f = null;
            }
        }
        c0() {
            let a = this.r == 0 ? 1 : this.r;
            if (this.p != null) {
                this.p.r = a;
            }
            for (let b = 0; b < this.actualActions.count; b++) {
                this.actualActions._inner[b].p = a;
            }
        }
        cd(a, b) {
        }
        cm() {
            this.cu();
        }
        cu() {
            if (this.z) {
                return;
            }
            if (this.c != null) {
                this.z = true;
                this.c.enqueueAction(runOn(this, this.ci));
            }
            else {
                this.aa = true;
            }
        }
        ci() {
            if (!this.z) {
                return;
            }
            this.z = false;
            this.cv();
            if (this.p.actions != this.actualActions) {
                this.p.actions = this.actualActions;
            }
        }
        cv() {
            this.actualActions.clear();
            for (let a = 0; a < this.autoGeneratedActions.count; a++) {
                this.actualActions.add(this.autoGeneratedActions._inner[a]);
            }
            let b = null;
            let c = null;
            let d = false;
            let e = false;
            let f = -1;
            let g = 0;
            for (let h = 0; h < this.actions.count; h++) {
                let i = this.actions._inner[h];
                if (!stringIsNullOrEmpty(i.dq)) {
                    if (((() => { let j = this.ac(i.dq, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                        b._inner[f].e1(i);
                    }
                }
                else {
                    if (!stringIsNullOrEmpty(i.cu)) {
                        if (i.h != null) {
                            i.h.actions.remove(i);
                        }
                        if (((() => { let j = this.ac(i.cu, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                            c = i.cu;
                            d = true;
                            e = false;
                        }
                    }
                    else if (!stringIsNullOrEmpty(i.cr)) {
                        if (i.h != null) {
                            i.h.actions.remove(i);
                        }
                        if (((() => { let j = this.ac(i.cr, this.actualActions, b, f); b = j.p2; f = j.p3; return j.ret; })())) {
                            c = i.cr;
                            d = false;
                            e = true;
                            g = 0;
                        }
                    }
                    if (!stringIsNullOrEmpty(c)) {
                        if (d) {
                            b.insert(f, i);
                            f++;
                        }
                        else if (e) {
                            b.insert(f + 1 + g, i);
                            g++;
                        }
                    }
                    else {
                        this.actualActions.add(i);
                    }
                }
            }
        }
        ac(a, b, c, d) {
            for (let e = 0; e < b.count; e++) {
                let f = b._inner[e];
                if (f.dn != null && f.dn == a) {
                    c = b;
                    d = e;
                    return {
                        ret: true,
                        p2: c,
                        p3: d
                    };
                }
                if (f.actions.count > 0) {
                    if (((() => { let g = this.ac(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
            }
            c = c;
            d = d;
            return {
                ret: false,
                p2: c,
                p3: d
            };
        }
        ad(a, b, c, d) {
            for (let e = 0; e < b.count; e++) {
                let f = b._inner[e];
                if (f.cz == null) {
                    if (f.dn != null && f.dn == a) {
                        c = b;
                        d = e;
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
                else if (f.cz != null && f.cz == a) {
                    c = b;
                    d = e;
                    return {
                        ret: true,
                        p2: c,
                        p3: d
                    };
                }
                if (f.actions.count > 0) {
                    if (((() => { let g = this.ac(a, f.actions, c, d); c = g.p2; d = g.p3; return g.ret; })())) {
                        return {
                            ret: true,
                            p2: c,
                            p3: d
                        };
                    }
                }
            }
            c = c;
            d = d;
            return {
                ret: false,
                p2: c,
                p3: d
            };
        }
        cj() {
            if (this.z) {
                this.ci();
            }
        }
        notifySizeChanged() {
            this.m.t();
        }
        destroy() {
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.m.u(a);
            if (this.u != null && this.m.j != null) {
                this.u.w(this.m.j);
            }
        }
        co(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.cs(a, b, c);
        }
        cs(a, b, c) {
            switch (a) {
                case "CellTextStyle":
                    if (this.u != null && this.m.j != null) {
                        this.u.w(this.m.j);
                    }
                    this.cz();
                    break;
                case "BackgroundColor":
                case "TextColor":
                case "SubmenuBackgroundColor":
                case "GroupHeaderBackgroundColorPropertyName":
                case "GroupHeaderTextColor":
                case "SeparatorBackgroundColor":
                case "HoverBackgroundColor":
                case "IconFill":
                case "IconStroke":
                case "ToolTipTextColor":
                case "ToolTipBackgroundColor":
                case "ToolTipCornerRadius":
                case "ToolTipElevation":
                case "Orientation":
                case "ShowOnHover":
                case "HighlightWidth":
                case "HighlightRadius":
                case "HighlightColor":
                    this.cz();
                    break;
                case "Target":
                    let d = c;
                    let e = b;
                    this.cq(e, d);
                    break;
                case "BaseTheme":
                    this.c0();
                    break;
                case "ExecutionContext":
                    if (this.c != null && this.aa) {
                        this.cu();
                        this.aa = false;
                    }
                    break;
            }
        }
        cz() {
            if (this.p != null) {
                this.p.ae = this.ae;
                this.p.ft = this.de;
                this.p.f4 = this.dp;
                this.p.fu = this.df;
                this.p.f3 = this.dn;
                this.p.fv = this.dg;
                this.p.fx = this.dh;
                this.p.f2 = this.dm;
                this.p.fz = this.dj;
                this.p.o = this.l;
                this.p.f6 = this.dr;
                this.p.f5 = this.dq;
                this.p.bv = this.a3;
                this.p.bw = this.a4;
                this.p.f0 = this.dk;
                this.p.f1 = this.dl;
                this.p.v = this.u;
                this.p.bo = this.aw;
                this.p.bp = this.ax;
                this.p.bq = this.ay;
                this.p.bn = this.av;
                this.p.bs = this.a0;
                this.p.bt = this.a1;
                this.p.bu = this.a2;
                this.p.br = this.az;
                this.p.fy = this.di;
                this.p.bl = this.at;
                this.p.bm = this.au;
            }
        }
        ds() {
            if (this.p != null) {
                return this.p.f7();
            }
            return Size.empty;
        }
        cq(a, b) {
            this.s = b;
            if (a != null) {
                a.commandCompleted = null;
                this.autoGeneratedActions.clear();
                a.removeCommandStateChangedListener(this);
                this.cu();
            }
            if (b != null) {
                b.commandCompleted = runOn(this, this.cr);
                b.invalidateActions = runOn(this, this.cp);
                this.autoGeneratedActions.clear();
                let c = b.getDesiredToolbarActions();
                if (c != null) {
                    for (let d = 0; d < c.length; d++) {
                        let e = ToolAction.g(c[d]);
                        this.autoGeneratedActions.add(e);
                    }
                }
                b.addCommandStateChangedListener(this);
                this.cu();
            }
        }
        get c() {
            return this.b;
        }
        set c(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.co("ExecutionContext", b, this.b);
            }
        }
        cg() {
            if (this.p != null) {
                this.p.dw();
            }
        }
        onCommandStateChanged(a, b, c) {
            let d = null;
            let e = -1;
            if (((() => { let f = this.ad(a, this.actualActions, d, e); d = f.p2; e = f.p3; return f.ret; })())) {
                let f = d._inner[e];
                switch (b) {
                    case 2:
                        switch (f.q) {
                            case 2:
                                f.f8 = c;
                                break;
                            case 5:
                                f.f9 = c;
                                break;
                            case 6:
                                f.f9 = c;
                                break;
                        }
                        break;
                    case 0:
                        f.f5 = EnumUtil.getEnumValue(Visibility_$type, c);
                        break;
                    case 1:
                        f.an = c;
                        break;
                }
            }
        }
        cw(a, b) {
            for (let c = 0; c < a.count; c++) {
                let d = a._inner[c];
                if (d.db == b) {
                    d.db = null;
                    d.db = b;
                }
                if (d.actions != null && d.actions.count > 0) {
                    this.cw(d.actions, b);
                }
            }
        }
        cx(a, b, c) {
            SvgIconRegistry.instance.addSvgPathString(a, b, c);
            this.cw(this.actualActions, b);
        }
        bj(a, b) {
            return SvgIconRegistry.instance.getSvgPathString(a, b);
        }
        cy(a, b, c) {
            SvgIconRegistry.instance.addSvgPathsString(a, b, c);
            this.cw(this.actualActions, b);
        }
        a(a, b) {
            return SvgIconRegistry.instance.getSvgPathsString(a, b);
        }
    }
    Toolbar.$t = /*@__PURE__*/ markType(Toolbar, 'Toolbar', Base.$, [INotifyPropertyChanged_$type, ICommandStateChangedListener_$type]);
    Toolbar.k = 1;
    Toolbar.a8 = null;
    return Toolbar;
})();
/**
 * @hidden
 */
export let ToolPanel = /*@__PURE__*/ (() => {
    class ToolPanel extends Base {
        get z() {
            if (this.y == null) {
                this.y = new SRProvider(this.p.n);
                this.y.cb("Layouts");
            }
            return this.y;
        }
        d1(a) {
            this.d = a;
            let b = this.d;
            b.rowUpdating = delegateCombine(b.rowUpdating, runOn(this, this.dr));
            let c = this.d;
            c.contentRefreshed = delegateCombine(c.contentRefreshed, runOn(this, this.dn));
            this.d.k = this.o;
            this.d.ai = true;
            let d = this.d;
            d.itemHeightRequested = delegateCombine(d.itemHeightRequested, runOn(this, this.dp));
            let e = this.d;
            e.itemWidthRequested = delegateCombine(e.itemWidthRequested, runOn(this, this.dq));
        }
        dn(a, b) {
            if (this.contentRefreshed != null) {
                this.contentRefreshed(this, new ToolPanelContentRefreshedEventArgs());
            }
        }
        dp(a, b) {
            let c = b.c;
            let d = new ToolActionMeasurementContext();
            this.d9(d);
            c.ed(this, d);
            if (c.f5 == 0) {
                if (!isNaN_(d.d)) {
                    b.a = d.d;
                }
                else {
                    b.a = this.d.av;
                }
            }
            else {
                b.a = 0;
            }
        }
        dq(a, b) {
            let c = b.c;
            let d = new ToolActionMeasurementContext();
            this.d9(d);
            c.ed(this, d);
            if (c.f5 == 0) {
                if (!isNaN_(d.e)) {
                    b.a = d.e;
                }
            }
            else {
                b.a = 0;
            }
        }
        dr(a, b) {
            let c = b.a.o;
            let d = a;
            if (this.o == 1) {
                let e = new ToolActionMeasurementContext();
                this.d9(e);
                c.ed(this, e);
                c.ex(d, this, b, e);
            }
            else {
                c.ex(d, this, b, this.i);
            }
        }
        d6(a) {
            this.ax = a.width;
            this.ed();
            this.d.notifySizeChanged();
        }
        get actions() {
            return this.g;
        }
        set actions(a) {
            let b = this.g;
            this.g = a;
            if (b != this.g) {
                this.d7("Actions", b, this.g);
            }
        }
        get ae() {
            return this.ac;
        }
        set ae(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.d7("ShowOnHover", b, this.ac);
            }
        }
        constructor() {
            super();
            this.p = null;
            this.x = null;
            this.by = null;
            this.aa = false;
            this.y = null;
            this.i = new ToolActionMeasurementContext();
            this.propertyChanged = null;
            this.g = new ToolActionCollection();
            this.contentRefreshed = null;
            this.ac = true;
            this.ab = false;
            this.ag = new Dictionary$2(String_$type, List$1.$.specialize(ToolAction.$), 0);
            this.ah = new Dictionary$2(String_$type, List$1.$.specialize(ToolAction.$), 0);
            this.af = new Dictionary$2(String_$type, ToolAction.$, 0);
            this.t = null;
            this.s = null;
            this.a = null;
            this.q = 0;
            this.e1 = null;
            this.en = null;
            this.fb = null;
            this.ex = null;
            this.e3 = null;
            this.ep = null;
            this.fa = null;
            this.ew = null;
            this.e4 = null;
            this.eq = null;
            this.e7 = null;
            this.et = null;
            this.d = null;
            this.ax = Number.POSITIVE_INFINITY;
            this.fc = null;
            this.ey = null;
            this.e2 = null;
            this.eo = null;
            this.e5 = null;
            this.er = null;
            this.fe = null;
            this.e0 = null;
            this.fd = null;
            this.ez = null;
            this.a6 = NaN;
            this.at = NaN;
            this.a7 = NaN;
            this.au = NaN;
            this.e8 = null;
            this.eu = null;
            this.e9 = null;
            this.ev = null;
            this.a3 = NaN;
            this.aq = NaN;
            this.a4 = NaN;
            this.ar = NaN;
            this.a5 = NaN;
            this.as = NaN;
            this.a2 = NaN;
            this.ap = NaN;
            this.az = NaN;
            this.am = NaN;
            this.a0 = NaN;
            this.an = NaN;
            this.a1 = NaN;
            this.ao = NaN;
            this.ay = NaN;
            this.al = NaN;
            this.m = ToolPanel.n;
            this.onCommand = null;
            this.aw = NaN;
            this.ak = NaN;
            this.av = NaN;
            this.aj = NaN;
            this.e6 = null;
            this.es = null;
            this.e = 0;
            this.drillDownRequested = null;
            this.drillUpRequested = null;
            let a = this.actions;
            a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.ds));
            NativeUIXInputsFactory.j();
            NativeUIInputsFactory.n();
            NativeUILayoutFactory.e();
            let b = new ToolPanelView();
            b.c = this;
            this.p = b;
            this.p.ac();
            this.em();
        }
        ds(a, b) {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, c) !== null) {
                        let d = c;
                        d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.d2));
                    }
                    c.d8();
                    c.f = null;
                    c.e5(null);
                }
            }
            if (b.newItems != null) {
                for (let e of fromEn(b.newItems)) {
                    if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                        let f = e;
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.d2));
                    }
                    e.f = this.a;
                    e.e5(this);
                }
            }
            this.el(this.actions);
            this.d5();
        }
        dt(a, b) {
            for (let c = 0; c < this.actions.count; c++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actions._inner[c]) !== null) {
                    let d = this.actions._inner[c];
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.d2));
                }
                this.actions._inner[c].d8();
                this.actions._inner[c].f = null;
                this.actions._inner[c].n = null;
            }
        }
        d5() {
            this.ed();
            this.p.z();
        }
        ed() {
            if (this.ab) {
                return;
            }
            this.ab = true;
            this.a.enqueueAction(runOn(this, this.dy));
        }
        ef() {
            this.ab = true;
            this.dy();
        }
        dy() {
            if (!this.ab) {
                return;
            }
            this.ab = false;
            this.du();
            this.ej();
            for (let a = 0; a < this.g.count; a++) {
                this.j(this.g._inner[a]);
            }
            this.dz();
        }
        du() {
            this.ag.clear();
            this.ah.clear();
            this.af.clear();
            for (let a = 0; a < this.g.count; a++) {
                this.g._inner[a].n = this;
                if (this.g._inner[a].dk != null) {
                    this.af.item(this.g._inner[a].dk, this.g._inner[a]);
                }
            }
            for (let b = 0; b < this.g.count; b++) {
                if (this.g._inner[b].dv != null) {
                    if (this.af.containsKey(this.g._inner[b].dv)) {
                        if (!this.ag.containsKey(this.g._inner[b].dv)) {
                            this.ag.item(this.g._inner[b].dv, new List$1(ToolAction.$, 0));
                        }
                        let c = this.ag.item(this.g._inner[b].dv);
                        c.add(this.g._inner[b]);
                    }
                }
            }
            for (let d = 0; d < this.g.count; d++) {
                if (this.g._inner[d].q == 6) {
                    let e = this.g._inner[d].gc;
                    if (e == null) {
                        e = "null";
                    }
                    if (!this.ah.containsKey(e)) {
                        this.ah.item(e, new List$1(ToolAction.$, 0));
                    }
                    this.ah.item(e).add(this.g._inner[d]);
                }
            }
        }
        ad(a) {
            if (a.dk == null) {
                return false;
            }
            return this.ag.containsKey(a.dk);
        }
        f(a) {
            if (this.af.containsKey(a)) {
                return this.af.item(a);
            }
            return null;
        }
        ai(a) {
            if (a.dk == null) {
                return null;
            }
            if (this.ag.containsKey(a.dk)) {
                return this.ag.item(a.dk);
            }
            return null;
        }
        j(a) {
            let b = new ToolActionMeasurementContext();
            this.d9(b);
            a.ed(this, b);
            this.d3(this.i, b);
            return b;
        }
        d9(a) {
            a.a = this.o;
            a.c = this.ax;
        }
        d3(a, b) {
            if (!isNaN_(b.f)) {
                if (isNaN_(a.f)) {
                    a.f = b.f;
                }
                else {
                    a.f = Math.max(a.f, b.f);
                }
            }
            if (!isNaN_(b.h)) {
                if (isNaN_(a.h)) {
                    a.h = b.h;
                }
                else {
                    a.h = Math.max(a.h, b.h);
                }
            }
        }
        ej() {
            this.i = new ToolActionMeasurementContext();
            this.i.a = this.o;
            this.i.c = this.ax;
        }
        f7() {
            let a = 0;
            let b = 0;
            if (this.o == 0) {
                for (let c = 0; c < this.actions.count; c++) {
                    let d = this.j(this.actions._inner[c]);
                    a = Math.max(d.e, a);
                    if (this.actions._inner[c].f5 == 0) {
                        if (!isNaN_(d.d)) {
                            b += d.d;
                        }
                        else {
                            b += this.ba;
                        }
                    }
                }
            }
            else if (this.o == 1) {
                for (let e = 0; e < this.actions.count; e++) {
                    let f = this.j(this.actions._inner[e]);
                    if (this.actions._inner[e].f5 == 0) {
                        if (!isNaN_(f.e)) {
                            a += f.e;
                        }
                    }
                    if (this.actions._inner[e].f5 == 0) {
                        if (!isNaN_(f.d)) {
                            b = f.d;
                        }
                        else {
                            b = this.ba;
                        }
                    }
                }
            }
            return new Size(1, a, b);
        }
        dz() {
            if (this.d.itemsSource != this.actions) {
                this.d.itemsSource = this.actions;
            }
        }
        d0() {
            if (this.ab) {
                this.dy();
            }
            if (this.d != null) {
                this.d.bw();
            }
        }
        eg() {
            if (this.d != null) {
                this.d.cp();
            }
        }
        ee(a) {
            let b = a.gc;
            if (b == null) {
                b = "null";
            }
            let c = a.dk;
            if (this.ah != null) {
                if (this.ah.containsKey(b)) {
                    for (let d = 0; d < this.ah.item(b).count; d++) {
                        if (this.ah.item(b)._inner[d].dk != c) {
                            this.ah.item(b)._inner[d].gf();
                        }
                    }
                }
            }
        }
        d2(a, b) {
            this.d5();
        }
        dv() {
            for (let a = 0; a < this.actions.count; a++) {
                this.actions._inner[a].d8();
            }
        }
        ea() {
            for (let a = 0; a < this.actions.count; a++) {
                if (typeCast(INotifyPropertyChanged_$type, this.actions._inner[a]) !== null) {
                    let b = this.actions._inner[a];
                    b.propertyChanged = delegateRemove(b.propertyChanged, runOn(this, this.d2));
                }
                this.actions._inner[a].f = null;
            }
        }
        notifySizeChanged() {
            this.p.y();
        }
        destroy() {
            this.provideContainer(null);
            this.dv();
        }
        provideContainer(a) {
            this.p.aa(a);
            if (this.v != null && this.p.n != null) {
                this.v.w(this.p.n);
            }
        }
        get v() {
            return this.t;
        }
        set v(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.d7("CellTextStyle", b, this.t);
            }
        }
        get u() {
            return this.s;
        }
        set u(a) {
            let b = this.s;
            this.s = a;
            if (b != this.s) {
                this.d7("ActualCellTextStyle", b, this.s);
            }
        }
        w() {
            if (this.v == null) {
                return this.p.f();
            }
            return this.v;
        }
        d7(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.eb(a, b, c);
        }
        eb(a, b, c) {
            switch (a) {
                case "BaseTheme":
                case "TextColor":
                case "BackgroundColor":
                case "SubmenuBackgroundColor":
                case "GroupHeaderTextColor":
                case "GroupHeaderBackgroundColor":
                case "SeparatorBackgroundColor":
                case "HoverBackgroundColor":
                case "IconFill":
                case "IconStroke":
                case "ToolTipTextColor":
                case "ToolTipBackgroundColor":
                case "ToolTipCornerRadius":
                case "ToolTipElevation":
                case "SeparatorHorizontalPaddingLeft":
                case "SeparatorHorizontalPaddingRight":
                case "SeparatorHorizontalPaddingTop":
                case "SeparatorHorizontalPaddingBottom":
                case "SeparatorVerticalPaddingLeft":
                case "SeparatorVerticalPaddingRight":
                case "SeparatorVerticalPaddingTop":
                case "SeparatorVerticalPaddingBottom":
                case "CellTextStyle":
                case "HighlightRadius":
                case "HighlightWidth":
                case "HighlightColor":
                    this.em();
                    break;
                case "ActualTextColor":
                case "ActualIconFill":
                case "ActualIconStroke":
                case "ActualSubmenuBackgroundColor":
                case "ActualGroupHeaderTextColor":
                case "ActualGroupHeaderBackgroundColor":
                case "ActualSeparatorBackgroundColor":
                case "ActualHoverBackgroundColor":
                case "ActualToolTipTextColor":
                case "ActualToolTipBackgroundColor":
                case "ActualToolTipCornerRadius":
                case "ActualToolTipElevation":
                case "ActualSeparatorHorizontalPaddingLeft":
                case "ActualSeparatorHorizontalPaddingRight":
                case "ActualSeparatorHorizontalPaddingTop":
                case "ActualSeparatorHorizontalPaddingBottom":
                case "ActualSeparatorVerticalPaddingLeft":
                case "ActualSeparatorVerticalPaddingRight":
                case "ActualSeparatorVerticalPaddingTop":
                case "ActualSeparatorVerticalPaddingBottom":
                case "ActualCellTextStyle":
                case "ActualHighlightRadius":
                case "ActualHighlightWidth":
                case "ActualHighlightColor":
                    this.el(this.actions);
                    break;
                case "ActualBackgroundColor":
                    this.ek();
                    break;
                case "Orientation":
                    if (this.d != null) {
                        this.d.k = this.o;
                        this.p.ad();
                    }
                    break;
                case "Actions":
                    if (b != null) {
                        let d = b;
                        d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.ds));
                        d.collectionResetting = delegateRemove(d.collectionResetting, runOn(this, this.dt));
                        for (let e of fromEnum(d)) {
                            if (typeCast(INotifyPropertyChanged_$type, e) !== null) {
                                let f = e;
                                f.propertyChanged = delegateRemove(f.propertyChanged, runOn(this, this.d2));
                            }
                            e.f = null;
                            e.e5(null);
                        }
                    }
                    if (c != null) {
                        let g = c;
                        g.collectionChanged = delegateCombine(g.collectionChanged, runOn(this, this.ds));
                        g.collectionResetting = delegateCombine(g.collectionResetting, runOn(this, this.dt));
                        for (let h of fromEnum(g)) {
                            if (typeCast(INotifyPropertyChanged_$type, h) !== null) {
                                let i = h;
                                i.propertyChanged = delegateCombine(i.propertyChanged, runOn(this, this.d2));
                            }
                            h.f = this.a;
                            h.e5(this);
                        }
                    }
                    this.el(this.actions);
                    this.ed();
                    break;
            }
        }
        em() {
            switch (this.r) {
                case 0:
                case 1:
                case 2:
                case 5:
                case 3:
                    this.fq = this.f4 != null ? this.f4 : BrushUtil.h(255, 24, 29, 31);
                    this.fg = this.fu != null ? this.fu : BrushUtil.h(102, 0, 0, 0);
                    this.ff = this.ft != null ? this.ft : BrushUtil.h(255, 255, 255, 255);
                    this.fp = this.f3 != null ? this.f3 : BrushUtil.h(255, 255, 255, 255);
                    this.fh = this.fv != null ? this.fv : BrushUtil.h(255, 237, 239, 245);
                    this.fj = this.fx != null ? this.fx : BrushUtil.h(255, 142, 143, 147);
                    this.fo = this.f2 != null ? this.f2 : BrushUtil.h(255, 237, 239, 245);
                    this.fi = this.fw != null ? this.fw : BrushUtil.h(25, 0, 0, 0);
                    this.fl = this.fz != null ? this.fz : BrushUtil.h(51, 178, 191, 220);
                    this.fs = this.f6 != null ? this.f6 : BrushUtil.h(255, 0, 0, 0);
                    this.fm = this.f0 != null ? this.f0 : BrushUtil.h(255, 0, 0, 0);
                    this.fn = this.f1 != null ? this.f1 : BrushUtil.h(255, 0, 0, 0);
                    this.fr = this.f5 != null ? this.f5 : BrushUtil.h(255, 237, 239, 245);
                    this.bj = !isNaN_(this.bv) ? this.bv : 8;
                    this.bk = !isNaN_(this.bw) ? this.bw : 4;
                    this.bg = !isNaN_(this.bs) ? this.bs : 0;
                    this.bh = !isNaN_(this.bt) ? this.bt : 0;
                    this.bi = !isNaN_(this.bu) ? this.bu : 0;
                    this.bf = !isNaN_(this.br) ? this.br : 0;
                    this.bc = !isNaN_(this.bo) ? this.bo : 0;
                    this.bd = !isNaN_(this.bp) ? this.bp : 0;
                    this.be = !isNaN_(this.bq) ? this.bq : DeviceUtils.g(10);
                    this.bb = !isNaN_(this.bn) ? this.bn : DeviceUtils.g(10);
                    this.u = this.v != null ? this.v : this.p.f();
                    this.fk = this.fy != null ? this.fy : BrushUtil.h(255, 110, 137, 247);
                    this.a8 = !isNaN_(this.bl) ? this.bl : 6;
                    this.a9 = !isNaN_(this.bm) ? this.bm : 1;
                    break;
                case 6:
                case 4:
                    this.fq = this.f4 != null ? this.f4 : BrushUtil.h(255, 255, 255, 255);
                    this.fg = this.fu != null ? this.fu : BrushUtil.h(102, 255, 255, 255);
                    this.ff = this.ft != null ? this.ft : BrushUtil.h(255, 55, 63, 86);
                    this.fp = this.f3 != null ? this.f3 : BrushUtil.h(255, 55, 63, 86);
                    this.fh = this.fv != null ? this.fv : BrushUtil.h(255, 44, 50, 70);
                    this.fj = this.fx != null ? this.fx : BrushUtil.h(255, 255, 255, 255);
                    this.fo = this.f2 != null ? this.f2 : BrushUtil.h(255, 44, 50, 70);
                    this.fi = this.fw != null ? this.fw : BrushUtil.h(25, 0, 0, 0);
                    this.fl = this.fz != null ? this.fz : BrushUtil.h(25, 105, 136, 255);
                    this.fs = this.f6 != null ? this.f6 : BrushUtil.h(255, 255, 255, 255);
                    this.fm = this.f0 != null ? this.f0 : BrushUtil.h(255, 210, 212, 216);
                    this.fn = this.f1 != null ? this.f1 : BrushUtil.h(255, 210, 212, 216);
                    this.fr = this.f5 != null ? this.f5 : BrushUtil.h(255, 44, 50, 70);
                    this.bj = !isNaN_(this.bv) ? this.bv : 8;
                    this.bk = !isNaN_(this.bw) ? this.bw : 4;
                    this.bg = !isNaN_(this.bs) ? this.bs : 0;
                    this.bh = !isNaN_(this.bt) ? this.bt : 0;
                    this.bi = !isNaN_(this.bu) ? this.bu : 0;
                    this.bf = !isNaN_(this.br) ? this.br : 0;
                    this.bc = !isNaN_(this.bo) ? this.bo : 0;
                    this.bd = !isNaN_(this.bp) ? this.bp : 0;
                    this.be = !isNaN_(this.bq) ? this.bq : DeviceUtils.g(10);
                    this.bb = !isNaN_(this.bn) ? this.bn : DeviceUtils.g(10);
                    this.u = this.v != null ? this.v : this.p.f();
                    this.fk = this.fy != null ? this.fy : BrushUtil.h(255, 110, 137, 247);
                    this.a8 = !isNaN_(this.bl) ? this.bl : 6;
                    this.a9 = !isNaN_(this.bm) ? this.bm : 1;
                    break;
            }
        }
        el(a) {
            for (let b = 0; b < a.count; b++) {
                a._inner[b].e9();
                this.el(a._inner[b].actions);
            }
        }
        ek() {
            if (this.p.n != null) {
                NativeUI.m(this.p.t, this.ff);
            }
        }
        get r() {
            return this.q;
        }
        set r(a) {
            let b = this.q;
            this.q = a;
            if (b != this.q) {
                this.d7("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get ft() {
            return this.e1;
        }
        set ft(a) {
            let b = this.e1;
            this.e1 = a;
            if (b != this.e1) {
                this.d7("BackgroundColor", b, a);
            }
        }
        get ff() {
            return this.en;
        }
        set ff(a) {
            let b = this.en;
            this.en = a;
            if (b != this.en) {
                this.d7("ActualBackgroundColor", b, this.en);
            }
        }
        get f3() {
            return this.fb;
        }
        set f3(a) {
            let b = this.fb;
            this.fb = a;
            if (b != this.fb) {
                this.d7("SubmenuBackgroundColor", b, this.fb);
            }
        }
        get fp() {
            return this.ex;
        }
        set fp(a) {
            let b = this.ex;
            this.ex = a;
            if (b != this.ex) {
                this.d7("ActualSubmenuBackgroundColor", b, this.ex);
            }
        }
        get fv() {
            return this.e3;
        }
        set fv(a) {
            let b = this.e3;
            this.e3 = a;
            if (b != this.e3) {
                this.d7("GroupHeaderBackgroundColor", b, this.e3);
            }
        }
        get fh() {
            return this.ep;
        }
        set fh(a) {
            let b = this.ep;
            this.ep = a;
            if (b != this.ep) {
                this.d7("ActualGroupHeaderBackgroundColor", b, this.ep);
            }
        }
        get f2() {
            return this.fa;
        }
        set f2(a) {
            let b = this.fa;
            this.fa = a;
            if (b != this.fa) {
                this.d7("SeparatorBackgroundColor", b, this.fa);
            }
        }
        get fo() {
            return this.ew;
        }
        set fo(a) {
            let b = this.ew;
            this.ew = a;
            if (b != this.ew) {
                this.d7("ActualSeparatorBackgroundColor", b, this.ew);
            }
        }
        get fw() {
            return this.e4;
        }
        set fw(a) {
            let b = this.e4;
            this.e4 = a;
            if (b != this.e4) {
                this.d7("GroupHeaderSeparatorBackgroundColor", b, this.e4);
            }
        }
        get fi() {
            return this.eq;
        }
        set fi(a) {
            let b = this.eq;
            this.eq = a;
            if (b != this.eq) {
                this.d7(ToolPanel.b4, b, this.eq);
            }
        }
        get fz() {
            return this.e7;
        }
        set fz(a) {
            let b = this.e7;
            this.e7 = a;
            if (b != this.e7) {
                this.d7("HoverBackgroundColor", b, this.e7);
            }
        }
        get fl() {
            return this.et;
        }
        set fl(a) {
            let b = this.et;
            this.et = a;
            if (b != this.et) {
                this.d7("ActualHoverBackgroundColor", b, this.et);
            }
        }
        get f4() {
            return this.fc;
        }
        set f4(a) {
            let b = this.fc;
            this.fc = a;
            if (b != this.fc) {
                this.d7("TextColor", b, this.fc);
            }
        }
        get fq() {
            return this.ey;
        }
        set fq(a) {
            let b = this.ey;
            this.ey = a;
            if (b != this.ey) {
                this.d7("ActualTextColor", b, this.ey);
            }
        }
        get fu() {
            return this.e2;
        }
        set fu(a) {
            let b = this.e2;
            this.e2 = a;
            if (b != this.e2) {
                this.d7("DisabledTextColor", b, this.e2);
            }
        }
        get fg() {
            return this.eo;
        }
        set fg(a) {
            let b = this.eo;
            this.eo = a;
            if (b != this.eo) {
                this.d7("ActualDisabledTextColor", b, this.eo);
            }
        }
        get fx() {
            return this.e5;
        }
        set fx(a) {
            let b = this.e5;
            this.e5 = a;
            if (b != this.e5) {
                this.d7("GroupHeaderTextColor", b, this.e5);
            }
        }
        get fj() {
            return this.er;
        }
        set fj(a) {
            let b = this.er;
            this.er = a;
            if (b != this.er) {
                this.d7("ActualGroupHeaderTextColor", b, this.er);
            }
        }
        get f6() {
            return this.fe;
        }
        set f6(a) {
            let b = this.fe;
            this.fe = a;
            if (b != this.fe) {
                this.d7("ToolTipTextColor", b, this.fe);
            }
        }
        get fs() {
            return this.e0;
        }
        set fs(a) {
            let b = this.e0;
            this.e0 = a;
            if (b != this.e0) {
                this.d7("ActualToolTipTextColor", b, this.e0);
            }
        }
        get f5() {
            return this.fd;
        }
        set f5(a) {
            let b = this.fd;
            this.fd = a;
            if (b != this.fd) {
                this.d7("ToolTipBackgroundColor", b, this.fd);
            }
        }
        get fr() {
            return this.ez;
        }
        set fr(a) {
            let b = this.ez;
            this.ez = a;
            if (b != this.ez) {
                this.d7("ActualToolTipBackgroundColor", b, this.ez);
            }
        }
        get bv() {
            return this.a6;
        }
        set bv(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.d7("ToolTipCornerRadius", b, this.a6);
            }
        }
        get bj() {
            return this.at;
        }
        set bj(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.d7("ActualToolTipCornerRadius", b, this.at);
            }
        }
        get bw() {
            return this.a7;
        }
        set bw(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.d7("ToolTipElevation", b, this.a7);
            }
        }
        get bk() {
            return this.au;
        }
        set bk(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.d7("ActualToolTipElevation", b, this.au);
            }
        }
        get f0() {
            return this.e8;
        }
        set f0(a) {
            let b = this.e8;
            this.e8 = a;
            if (b != this.e8) {
                this.d7("IconFill", b, this.e8);
            }
        }
        get fm() {
            return this.eu;
        }
        set fm(a) {
            let b = this.eu;
            this.eu = a;
            if (b != this.eu) {
                this.d7("ActualIconFill", b, this.eu);
            }
        }
        get f1() {
            return this.e9;
        }
        set f1(a) {
            let b = this.e9;
            this.e9 = a;
            if (b != this.e9) {
                this.d7("IconStroke", b, this.e9);
            }
        }
        get fn() {
            return this.ev;
        }
        set fn(a) {
            let b = this.ev;
            this.ev = a;
            if (b != this.ev) {
                this.d7("ActualIconStroke", b, this.ev);
            }
        }
        get bs() {
            return this.a3;
        }
        set bs(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.d7("SeparatorVerticalPaddingLeft", b, this.a3);
            }
        }
        get bg() {
            return this.aq;
        }
        set bg(a) {
            let b = this.aq;
            this.aq = a;
            if (b != this.aq) {
                this.d7("ActualSeparatorVerticalPaddingLeft", b, this.aq);
            }
        }
        get bt() {
            return this.a4;
        }
        set bt(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.d7("SeparatorVerticalPaddingRight", b, this.a4);
            }
        }
        get bh() {
            return this.ar;
        }
        set bh(a) {
            let b = this.ar;
            this.ar = a;
            if (b != this.ar) {
                this.d7("ActualSeparatorVerticalPaddingRight", b, this.ar);
            }
        }
        get bu() {
            return this.a5;
        }
        set bu(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.d7("SeparatorVerticalPaddingTop", b, this.a5);
            }
        }
        get bi() {
            return this.as;
        }
        set bi(a) {
            let b = this.as;
            this.as = a;
            if (b != this.as) {
                this.d7("ActualSeparatorVerticalPaddingTop", b, this.as);
            }
        }
        get br() {
            return this.a2;
        }
        set br(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.d7("SeparatorVerticalPaddingBottom", b, this.a2);
            }
        }
        get bf() {
            return this.ap;
        }
        set bf(a) {
            let b = this.ap;
            this.ap = a;
            if (b != this.ap) {
                this.d7("ActualSeparatorVerticalPaddingBottom", b, this.ap);
            }
        }
        get bo() {
            return this.az;
        }
        set bo(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.d7("SeparatorHorizontalPaddingLeft", b, this.az);
            }
        }
        get bc() {
            return this.am;
        }
        set bc(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.d7("ActualSeparatorHorizontalPaddingLeft", b, this.am);
            }
        }
        get bp() {
            return this.a0;
        }
        set bp(a) {
            let b = this.a0;
            this.a0 = a;
            if (b != this.a0) {
                this.d7("SeparatorHorizontalPaddingRight", b, this.a0);
            }
        }
        get bd() {
            return this.an;
        }
        set bd(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.d7("ActualSeparatorHorizontalPaddingRight", b, this.an);
            }
        }
        get bq() {
            return this.a1;
        }
        set bq(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.d7("SeparatorHorizontalPaddingTop", b, this.a1);
            }
        }
        get be() {
            return this.ao;
        }
        set be(a) {
            let b = this.ao;
            this.ao = a;
            if (b != this.ao) {
                this.d7("ActualSeparatorHorizontalPaddingTop", b, this.ao);
            }
        }
        get bn() {
            return this.ay;
        }
        set bn(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.d7("SeparatorHorizontalPaddingBottom", b, this.ay);
            }
        }
        get bb() {
            return this.al;
        }
        set bb(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.d7("ActualSeparatorHorizontalPaddingBottom", b, this.al);
            }
        }
        get o() {
            return this.m;
        }
        set o(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.d7("Orientation", enumGetBox(ToolPanelOrientation_$type, b), enumGetBox(ToolPanelOrientation_$type, a));
            }
        }
        d8(a, b) {
            if (this.onCommand != null) {
                this.onCommand(this, b);
            }
            if (a.q == 6) {
                this.ee(a);
            }
        }
        get bx() {
            return this.d.a9;
        }
        set bx(a) {
            this.d.a9 = a;
        }
        get ba() {
            return this.d.av;
        }
        get bm() {
            return this.aw;
        }
        set bm(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.d7("HighlightWidth", b, this.aw);
            }
        }
        get a9() {
            return this.ak;
        }
        set a9(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.d7("ActualHighlightWidth", b, this.ak);
            }
        }
        get bl() {
            return this.av;
        }
        set bl(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.d7("HighlightRadius", b, this.av);
            }
        }
        get a8() {
            return this.aj;
        }
        set a8(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.d7("ActualHighlightRadius", b, this.aj);
            }
        }
        get fy() {
            return this.e6;
        }
        set fy(a) {
            let b = this.e6;
            this.e6 = a;
            if (b != this.e6) {
                this.d7("HighlightColor", b, this.e6);
            }
        }
        get fk() {
            return this.es;
        }
        set fk(a) {
            let b = this.es;
            this.es = a;
            if (b != this.es) {
                this.d7("ActualHighlightColor", b, this.es);
            }
        }
        eh(a) {
            if (this.drillDownRequested != null) {
                this.drillDownRequested(this, ((() => {
                    let $ret = new DrillDownRequestedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        ei(a) {
            if (this.drillUpRequested != null) {
                this.drillUpRequested(this, ((() => {
                    let $ret = new DrillDownRequestedEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        dw() {
            for (let a = 0; a < this.actions.count; a++) {
                this.actions._inner[a].ea();
            }
        }
    }
    ToolPanel.$t = /*@__PURE__*/ markType(ToolPanel, 'ToolPanel', Base.$, [INotifyPropertyChanged_$type]);
    ToolPanel.b4 = "ActualGroupHeaderSeparatorBackgroundColor";
    ToolPanel.n = 0;
    return ToolPanel;
})();
/**
 * @hidden
 */
export let DrillDownRequestedEventArgs = /*@__PURE__*/ (() => {
    class DrillDownRequestedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
    }
    DrillDownRequestedEventArgs.$t = /*@__PURE__*/ markType(DrillDownRequestedEventArgs, 'DrillDownRequestedEventArgs');
    return DrillDownRequestedEventArgs;
})();
/**
 * @hidden
 */
export let ToolPanelsPresenter = /*@__PURE__*/ (() => {
    class ToolPanelsPresenter extends Base {
        get a0() {
            return this.ay;
        }
        set a0(a) {
            this.d.d = this.ay = a;
        }
        get a1() {
            return this.az;
        }
        set a1(a) {
            this.g.d = this.az = a;
        }
        get v() {
            return this.u;
        }
        get n() {
            return this.m;
        }
        set n(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.as("Theme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.m));
            }
        }
        get z() {
            return this.x;
        }
        set z(a) {
            this.x = a;
        }
        constructor(a, b) {
            super();
            this.ab = null;
            this.i = null;
            this.j = null;
            this.y = 0;
            this.o = null;
            this.a = null;
            this.d = null;
            this.g = null;
            this.ay = null;
            this.az = null;
            this.p = null;
            this.b = null;
            this.e = null;
            this.h = null;
            this.c = null;
            this.f = null;
            this.w = new Queue$1(PanelAnimationRequest.$);
            this.r = null;
            this.q = null;
            this.u = new List$1(PanelInfo.$, 0);
            this.m = 1;
            this.x = 200;
            this.s = null;
            this.aa = 0;
            this.t = false;
            this.containerReady = null;
            this.sizeChanged = null;
            this.propertyChanged = null;
            this.ab = a;
            this.i = b;
        }
        ai(a) {
            NativeUIComponent.at(this.ab, [7, 9], (b) => {
                this.r = b[0];
                this.q = b[1];
                this.r.bj(this.q);
                this.q.a9 = new MatrixTransform();
                if (a != null) {
                    a();
                }
            });
        }
        a2() {
            if (this.j != null) {
                return this.j.f();
            }
            return this.r.bb(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        }
        ae(a, b = null) {
            for (let c = 0; c < this.v.count; c++) {
                if (this.v._inner[c].b == a) {
                    if (b != null) {
                        b(this.v._inner[c].a);
                    }
                    return;
                }
            }
            NativeUIComponent.ar(this.ab, 13, (d) => {
                let e = d;
                e.c = this.n;
                e.b2 = a.n.f4;
                e.bx = a.n.fu;
                e.bw = a.n.f3;
                e.b1 = a.n.f3;
                e.by = a.n.fv;
                e.bz = a.n.fx;
                e.b0 = a.n.f2;
                e.br = a.n.u;
                e.bp = a.actions;
                e.bi = runOn(this, this.aq);
                e.bj = runOn(this, this.ar);
                e.bo = runOn(this, this.ao);
                this.q.bj(e);
                this.y = 0;
                for (let f = 0; f < this.v.count; f++) {
                    let g = this.v._inner[f].f();
                    this.y += g.width;
                    this.v._inner[f].a.ad = g.width;
                }
                this.q.bq(e, this.y);
                this.q.br(e, 0);
                this.v.add(new PanelInfo(a, e, this.y));
                this.av();
                if (b != null) {
                    b(e);
                }
            });
        }
        aj(a) {
            for (let b = 0; b < this.v.count; b++) {
                if (this.v._inner[b].a == a) {
                    this.al(b);
                }
            }
        }
        al(a) {
            this.ak(this.v._inner[a]);
        }
        ak(a, b = null) {
            this.af(a, -Math.floor(a.c), b);
            this.j = a;
        }
        aq(a, b) {
            this.aa++;
            if (this.v.count > 1 && this.aa < this.v.count) {
                for (let c = this.v.count - 1; c > this.aa; c--) {
                    this.v._inner[c].a.bi = null;
                    this.v._inner[c].a.bj = null;
                    this.q.bl(this.v._inner[c].a);
                    this.y -= this.v._inner[c].a.ad;
                    this.v.removeAt(c);
                }
                if (this.v._inner[this.aa].b == b.a) {
                    this.aj(this.v._inner[this.aa].a);
                    return;
                }
                else {
                    this.v._inner[this.aa].a.bi = null;
                    this.v._inner[this.aa].a.bj = null;
                    this.q.bl(this.v._inner[this.aa].a);
                    this.y -= this.v._inner[this.aa].a.ad;
                    this.v.removeAt(this.aa);
                }
            }
            this.ae(b.a, (d) => this.i.executeDelayed(() => this.aj(d), 0));
        }
        ar(a, b) {
            this.aa = Math.max(0, this.aa - 1);
            this.ak(this.v._inner[this.aa], () => {
            });
        }
        ao(a, b) {
            if (this.s != null) {
                this.s(b);
            }
        }
        af(a, b, c = null) {
            this.ah();
            if (this.q.a9 == null) {
                let d = a.f();
                this.r.ad = Math.floor(d.width);
                this.r.x = Math.floor(d.height);
                return;
            }
            if (this.o.playState == 1) {
                if ((this.o.playbackRate > 0 && this.a0.j == b) || (this.o.playbackRate < 0 && this.a1.j == b)) {
                    this.o.reverse();
                    this.p.reverse();
                }
                else {
                    this.w.g(((() => {
                        let $ret = new PanelAnimationRequest();
                        $ret.a = a;
                        $ret.c = b;
                        $ret.b = c;
                        return $ret;
                    })()));
                }
            }
            else {
                this.a0 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = this.a1.j;
                    return $ret;
                })());
                this.a1 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = b;
                    return $ret;
                })());
                let e = a.f();
                this.e.d = this.r.ad;
                this.c.d = this.r.x;
                this.h.d = Math.floor(e.width);
                this.f.d = Math.floor(e.height);
                this.o.updatePlaybackRate(1);
                this.o.play();
                this.o.finished.f((f) => this.an(c));
                this.p.updatePlaybackRate(1);
                this.p.play();
                this.p.finished.f((f) => {
                    if (this.p != null) {
                        this.p.commitStyles();
                    }
                });
            }
        }
        ah() {
            if (this.o == null) {
                let a = new AnimationKeyFrameEffectTiming();
                a.g = this.z;
                a.b = 0;
                this.a = new AnimationKeyFrameEffect(0, this.q.al, 0, null, a);
                this.ay = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = 0;
                    return $ret;
                })());
                this.az = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = 0;
                    return $ret;
                })());
                this.d = new AnimationKeyFrameProperty(14, this.ay);
                this.g = new AnimationKeyFrameProperty(14, this.az);
                this.o = KeyFrameAnimationFactory.f.c(this.a.m(this.d).m(this.g));
                this.b = new AnimationKeyFrameEffect(0, this.r.al, 0, null, a);
                this.e = new AnimationKeyFrameProperty(9, 0);
                this.c = new AnimationKeyFrameProperty(10, 0);
                this.h = new AnimationKeyFrameProperty(9, 0);
                this.f = new AnimationKeyFrameProperty(10, 0);
                this.p = KeyFrameAnimationFactory.f.c(this.b.m(this.e, this.c).m(this.h, this.f));
            }
        }
        an(a) {
            if (this.o != null) {
                this.o.commitStyles();
            }
            if (a != null) {
                a();
            }
            if (this.o.playbackRate < 0) {
                let b = this.a1.j;
                this.a1 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = this.a0.j;
                    return $ret;
                })());
                this.a0 = ((() => {
                    let $ret = new TranslateTransform();
                    $ret.j = b;
                    return $ret;
                })());
            }
            if (this.w.count > 0) {
                let c = this.w.b();
                this.ak(c.a, c.b);
            }
        }
        av() {
            if (this.t) {
                return;
            }
            this.t = true;
            this.i.enqueueAction(runOn(this, this.ag));
        }
        ag() {
            if (!this.t) {
                return;
            }
            this.t = false;
            for (let a = 0; a < this.v.count; a++) {
                this.v._inner[a].e();
                let b = this.v._inner[a].f();
                this.v._inner[a].a.ad = b.width;
                this.v._inner[a].a.x = b.height;
                this.v._inner[a].a.bu(b);
                if (this.o.playState != 1) {
                    if (this.aa == a) {
                        this.r.ad = b.width;
                        this.r.x = b.height;
                    }
                }
            }
        }
        aw() {
            this.aa = 0;
            this.q.a9 = new MatrixTransform();
            let a = this.v._inner[0].f();
            this.r.ad = Math.floor(a.width);
            this.r.x = Math.floor(a.height);
            this.ay = ((() => {
                let $ret = new TranslateTransform();
                $ret.j = 0;
                return $ret;
            })());
            this.az = ((() => {
                let $ret = new TranslateTransform();
                $ret.j = 0;
                return $ret;
            })());
        }
        ax(a, b) {
            this.m = a;
            for (let c = 0; c < this.v.count; c++) {
                let d = this.v._inner[c].a;
                d.c = a;
                d.b2 = b.f4;
                d.bx = b.fu;
                d.bw = b.f3;
                d.b1 = b.f3;
                d.by = b.fv;
                d.bz = b.fx;
                d.b0 = b.f2;
            }
        }
        am() {
            let a = this.v._inner[0].f();
            this.v._inner[0].a.ad = a.width;
            this.v._inner[0].a.x = a.height;
            this.v._inner[0].d(a);
        }
        ap() {
            if (this.containerReady != null) {
                this.containerReady(this);
            }
        }
        at() {
            if (this.sizeChanged != null) {
                this.sizeChanged(this);
            }
        }
        as(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.au(a, b, c);
        }
        au(a, b, c) {
            switch (a) {
                case "Theme":
                    for (let d = 0; d < this.v.count; d++) {
                        this.v._inner[d].a.c = this.n;
                    }
                    break;
            }
        }
    }
    ToolPanelsPresenter.$t = /*@__PURE__*/ markType(ToolPanelsPresenter, 'ToolPanelsPresenter', Base.$, [INotifyPropertyChanged_$type]);
    return ToolPanelsPresenter;
})();
/**
 * @hidden
 */
export let PanelInfo = /*@__PURE__*/ (() => {
    class PanelInfo extends Base {
        constructor(a, b, c) {
            super();
            this.c = 0;
            this.a = null;
            this.b = null;
            this.b = a;
            this.a = b;
            this.c = c;
        }
        f() {
            return this.a.bb(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        }
        e() {
            this.a.bv();
        }
        d(a) {
            this.a.bu(a);
        }
    }
    PanelInfo.$t = /*@__PURE__*/ markType(PanelInfo, 'PanelInfo');
    return PanelInfo;
})();
/**
 * @hidden
 */
export let PanelAnimationRequest = /*@__PURE__*/ (() => {
    class PanelAnimationRequest extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.c = 0;
            this.b = null;
        }
    }
    PanelAnimationRequest.$t = /*@__PURE__*/ markType(PanelAnimationRequest, 'PanelAnimationRequest');
    return PanelAnimationRequest;
})();
