import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionSubPanel } from "./ToolActionSubPanel";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcToolActionSubPanelComponent = /*@__PURE__*/ (() => {
    class IgcToolActionSubPanelComponent extends IgcToolActionComponent {
        createImplementation() {
            return new ToolActionSubPanel();
        }
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcToolActionSubPanelComponent._observedAttributesIgcToolActionSubPanelComponent == null) {
                let names = getAllPropertyNames(IgcToolActionSubPanelComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionSubPanelComponent._observedAttributesIgcToolActionSubPanelComponent = names;
            }
            return IgcToolActionSubPanelComponent._observedAttributesIgcToolActionSubPanelComponent;
        }
        static register() {
            if (!IgcToolActionSubPanelComponent._isElementRegistered) {
                IgcToolActionSubPanelComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcToolActionSubPanelComponent.htmlTagName, IgcToolActionSubPanelComponent);
            }
        }
        fromInfo(info) {
            this.i.ej(info);
        }
    }
    IgcToolActionSubPanelComponent._observedAttributesIgcToolActionSubPanelComponent = null;
    IgcToolActionSubPanelComponent.htmlTagName = "igc-tool-action-sub-panel";
    IgcToolActionSubPanelComponent._isElementRegistered = false;
    return IgcToolActionSubPanelComponent;
})();
