import { __extends } from "tslib";
import { IgcToolActionComponent } from "./igc-tool-action-component";
import { ToolActionSubPanel } from "./ToolActionSubPanel";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
var IgcToolActionSubPanelComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcToolActionSubPanelComponent, _super);
    function IgcToolActionSubPanelComponent() {
        return _super.call(this) || this;
    }
    IgcToolActionSubPanelComponent.prototype.createImplementation = function () {
        return new ToolActionSubPanel();
    };
    Object.defineProperty(IgcToolActionSubPanelComponent.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionSubPanelComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcToolActionSubPanelComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcToolActionSubPanelComponent, "observedAttributes", {
        get: function () {
            if (IgcToolActionSubPanelComponent._observedAttributesIgcToolActionSubPanelComponent == null) {
                var names = getAllPropertyNames(IgcToolActionSubPanelComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcToolActionSubPanelComponent._observedAttributesIgcToolActionSubPanelComponent = names;
            }
            return IgcToolActionSubPanelComponent._observedAttributesIgcToolActionSubPanelComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcToolActionSubPanelComponent.register = function () {
        if (!IgcToolActionSubPanelComponent._isElementRegistered) {
            IgcToolActionSubPanelComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcToolActionSubPanelComponent.htmlTagName, IgcToolActionSubPanelComponent);
        }
    };
    IgcToolActionSubPanelComponent.prototype.fromInfo = function (info) {
        this.i.ej(info);
    };
    IgcToolActionSubPanelComponent._observedAttributesIgcToolActionSubPanelComponent = null;
    IgcToolActionSubPanelComponent.htmlTagName = "igc-tool-action-sub-panel";
    IgcToolActionSubPanelComponent._isElementRegistered = false;
    return IgcToolActionSubPanelComponent;
}(IgcToolActionComponent));
export { IgcToolActionSubPanelComponent };
