import { IgcToolActionIconButtonComponent } from "./igc-tool-action-icon-button-component";
import { ToolActionIconMenu } from "./ToolActionIconMenu";
export declare class IgcToolActionIconMenuComponent extends IgcToolActionIconButtonComponent {
    protected createImplementation(): ToolActionIconMenu;
    /**
                                 * @hidden
                                 */
    get i(): ToolActionIconMenu;
    constructor();
    connectedCallback(): void;
    disconnectedCallback(): void;
    private static _observedAttributesIgcToolActionIconMenuComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
     * Gets or sets the stroke color of the arrow icon.
    */
    get arrowStroke(): string;
    set arrowStroke(v: string);
    /**
     * Gets the actual stroke color of the arrow icon.
    */
    get actualArrowStroke(): string;
    set actualArrowStroke(v: string);
    /**
     * Gets or sets whether the arrow icon should be shown.
    */
    get showArrowIcon(): boolean;
    set showArrowIcon(v: boolean);
}
